MHP = MHP or {}

MHP.settings = {
	interpolate_score = true,
	interp_duration = 2,
	hit_indicator_duration = 2
}

MHP._update_intervals = {
	dodge = 0.1,
	dodge_t = math.random(),
	crit = 0.1,
	crit_t = math.random(),
	resist = 0.1,
	resist_t = math.random(),
	weapon = 0.1,
	weapon_t = math.random(),
	money = 1,
	money_t = math.random(),
	katamari_t = 0,
	katamari = 1/30,
	doomface = 0.5,
	doomface_t = math.random()
}

MHP.info = MHP.info or {
	health_current = 1,
	health_total = 1,
	current_clip = 0,
	max_clip = 1,
	
	crit = 0,
	dodge = 0,
	resist = 0,
	hit = 0,
	stamina = 0,
	damage = 0,
	weapon_name = "Sectoid Plasma Pistol",
	
	valor = 1,
	valor_rank_id = -1,
	is_animating_d2 = false,
	
	hlm_combos = {
		count = 0,
		end_t = 0,
		last_pos = Vector3()
	},
	
	shooting_t = nil,
	
--	stored_health = 0,
	
	money = 0,
	money_interp = 0,
	money_interp_start = 0,
	money_interp_t = 0,
	
	xp = 0,
	xp_interp = 0,
	xp_interp_start = 0,
	xp_interp_t = 0,
	
	score = 0,
	score_interp = 0,
	score_interp_t = 0,
	score_interp_duration = 2,

	hit_indicators = {},
	doom_hit_angle = "center",
	current_katamari = 0
}

MHP._animate_targets = {}

MHP._huds = {
	hotline_miami = {
		panel = nil,
		scale = 2,
		BOX_W = 128,
		BOX_H = 25,
		rot_speed = 256,
		FONT_SIZE = 16,
		COMBO_FONT_SIZE = 56,
		combo_rot_speed = 512,
		combo_rot_distance = 2,
		combo_time = 2,
		min_combo = 3,
		combo_string = "$COMBOx combo",
		combo_macro = "$COMBO",
		combo_anim_height = -100
	},
	vats = {
		panel = nil,
		BAR_X = 4,
		bodies = {
--			"Hips",
			"Spine",
--			"Spine1",
--			"Spine2",
--			"Neck",
			"Head",
--			"LeftShoulder",
			"LeftArm",
--			"LeftForeArm",
--			"RightShoulder",
			"RightArm",
--			"RightForeArm",
--			"LeftUpLeg",
			"LeftLeg",
--			"LeftFoot",
--			"RightUpLeg",
			"RightLeg",
--			"RightFoot"
		}
	},
	minecraft = {
		panel = nil,
		HEALTH_TICKS = 10,
		ARMOR_TICKS = 10,
		HUNGER_TICKS = 10,
		HOTBAR_SLOTS = 9,
		DEFAULT_SIZE = 36,
		SCALE = 0.5,
		atlas_name = "textures/minecraft_atlas",
		get_rect = function(kiddo) --get it? get "rect"? like "rekt", but- hey wait where are you going
			local item = (type(kiddo) == "table" and kiddo) or MHP._huds.minecraft.atlas[tostring(kiddo)]
			local size = MHP._huds.minecraft.DEFAULT_SIZE
			local size = MHP._huds.minecraft.DEFAULT_SIZE
			if item then 
				local x,y = unpack(item)
				return {size * x, size * y, size, size}
			end
			return {0,0,size,size}
		end,
		atlas = {
			health_empty_black = {0,0},
			health_empty_white = {1,0},
			health_empty_red = {2,0},
			health_heart_full = {3,0},
			health_heart_half = {4,0},
			health_transparent_full = {5,0},
			health_transparent_half = {6,0},
			armor_empty = {0,1},
			armor_half = {1,1},
			armor_full = {2,1},
			hunger_empty_black = {0,2},
			hunger_empty_white = {1,2},
			hunger_empty_red = {2,2},
			hunger_heart_full = {3,2},
			hunger_heart_half = {4,2},
			hunger_transparent_full = {5,2},
			hunger_transparent_half = {6,2}
		}
	},
	tf2 = {
		HEALTH_SCALE = 0.75,
		HEALTH_BITMAP_W = 128,
		HEALTH_BITMAP_H = 128,
		AMMO_TEXT_X = 118,
		HEALTH_LOW_THRESHOLD = 1/2,
		AMMO_LOW_THRESHOLD = 1/5,
		AMMO_GHOST_ALPHA = 0.3,
		AMMO_GHOST_SIZE_MUL = 1.1,
		panel = nil
	},
	hl2 = {
		panel = nil
	},
	lego = {
		panel = nil,
		SIZE = 96,
		atlas_name = "textures/lego_characters_atlas"
	},
	pogo = {
		panel = nil,
		SIZE = 128,
		SCALE = 0.5,
		get_rect = function(name)
			local item = (type(name) == "table" and name) or MHP._huds.pogo.atlas[tostring(name)]
			local size = MHP._huds.pogo.SIZE
			if item then 
				local x,y = unpack(item)
				return {size * x, size * y, size, size}
			end
			return {0,0,size,size}
		end,
		atlas = {
			dex = {0,0},
			shop = {1,0},
			bag = {0,1},
			camera = {1,1},
			run = {0,2},
			ar = {1,2}
		},
		atlas_name = "textures/pogo_icons_atlas"
	},
	xcom = {
		panel = nil,
		BOX_W = 440,
		BOX_H = 116,
		SCALE = 1,
		VER_OFFSET = 128,
		action_name_string = "Fire ($WEAPON_NAME)",
		action_desc_string = "Does up to $DAMAGE damage.",
		hit_chance_string = "$CHANCE% to hit",
		crit_chance_string = "$CHANCE% critical"		
	},
	portal = {
		panel = nil,
		SCALE = 0.25,
		CROSSHAIR_H = 200,
		CROSSHAIR_W = 128
	},
	gta = {
		panel = nil,
		military_time = true,
		show_ampm = false,
		cash_digits = 8,
		font_size = 32
	},
	stardew = {
		get_season_icon = function(season_name)
			local data = MHP._huds.stardew
			local place = data.seasons[season_name] - 1
			local w = data.season_w
			local h = data.season_h
			return {0,place * h,w,h}
		end,
		get_weather_icon = function(weather_name)
			local data = MHP._huds.stardew
			local place = data.weather[weather_name] - 1
			local w = data.weather_w
			local h = data.weather_h
			return {0,place * h,w,h}	
		end,
		seasons = { --just some enums
			Spring = 1,
			Summer = 2,
			Fall = 3,
			Winter = 4
		},
		weather = {
			sun = 1,
			rain = 2,
			storm = 3,
			snow = 4,
			wind_fall = 5,
			wind_spring = 6,
			festival = 7,
			wedding = 8
		},
		weather_ids = {
			["Thunderstorm"] = "storm",
			["Drizzle"] = "rain",
			["Rain"] = "rain",
			["Snow"] = "snow",
			["Atmosphere"] = "wedding", --stardew does not have an icon for "disastrous weather, do not leave your house under any circumstances"
			["Clear"] = "sun",
			["Clouds"] = "wind"
		},
		atlas_name = "textures/stardew_atlas", --not used
		weather_atlas_name = "textures/stardew_weather",
		seasons_atlas_name = "textures/stardew_seasons",
		
		season_w = 24, --rect only
		season_h = 16,
		weather_w = 24,
		weather_h = 16,
		
		scale = 1,
		cash_digits = 8,
		clock_font_size = 20,
		money_font_size = 28,
		bar_font_size = 16,
		bar_low_threshold = 0.5,
		bar_empty_threshold = 0.25,
		bar_shake_speed = 10000,
		bar_shake_intensity_ver = 2,
		bar_shake_intensity_hor = 2,
		max_shake_money = 100000,
		STARDEW_HUD_X = -160,
		STARDEW_HUD_Y = 16,
		STARDEW_HUD_W = 156,
		STARDEW_HUD_H = 156,
		STARDEW_VITALS_W = 24,
		STARDEW_VITALS_H = 136,
		STARDEW_VITALS_X = -16,
		STARDEW_VITALS_Y = 420,
		STARDEW_CLOCK_HAND_X = 40,
		STARDEW_CLOCK_HAND_Y = 10,
		STARDEW_SEASON_W = 24,
		STARDEW_SEASON_H = 16,
		STARDEW_SEASON_X = 111,
		STARDEW_SEASON_Y = 38,
		STARDEW_WEATHER_W = 24,
		STARDEW_WEATHER_H = 16,
		STARDEW_WEATHER_X = 63,
		STARDEW_WEATHER_Y = 38,
		STARDEW_DATE_X = 22,
		STARDEW_DATE_Y = 16,
		STARDEW_CLOCK_X = 22,
		STARDEW_CLOCK_Y = 61,
		STARDEW_MONEY_X = 26,
		STARDEW_MONEY_Y = 94,
		STARDEW_MONEY_SPACER = 12,
		STARDEW_BAR_W = 16,
		STARDEW_BAR_H = 16,
		show_ampm = true,
		military_time = false,
		STARDEW_BAR_X = 6,
		STARDEW_BAR_Y = 26,
		STARDEW_BAR_W = 12,
		STARDEW_BAR_H = 106,
		panel = nil
	},
	katamari = {
		panel = nil,
		atlas_name = "textures/katamari_atlas",
		idle_frames = 24,
		active_frames = 14,
		rect_h = 350,
		rect_w = 300,
		prince_scale = 0.5
	},
	doom = {
		panel = nil,
		portrait_size = 64,
		get_rect = function(name,hurt_level)
			local size = MHP._huds.doom.portrait_size
			local x = 0
			local y = 0
			name = tostring(name)
			if MHP._huds.doom.atlas[name] then 
				x,y = unpack(MHP._huds.doom.atlas[name])
				return {x * size,y * size,size,size}
			elseif MHP._huds.doom.atlas.expressions[name] then
				x = MHP._huds.doom.atlas.expressions[name]
				hurt_level = tonumber(hurt_level) or math.round(4 * (1 - (MHP.info.health_current / MHP.info.health_total)))
				return {x * size,hurt_level * size,size,size}
			end
			return {0,0,size,size}
		end,
		atlas = {
			expressions = {
				EVL = 0, -- grin
				KILL = 1, --grit
				OUCH = 2, --shock
				TR = 3, --look right
				ST = 4, --look forward
				TL = 5, --look left
				KILL_TL = 6, --grit look left
				KILL_TR = 7 --grit look right
			},
			DEAD = {0,5},
			GOD = {1,5}
		},
		DAMAGE_TIERS = 4, --5, technically, except we count from 0
		ver_offset = 16,
		font_size = 56,
		font_y = 24,
		health_low_threshold = 0.5,
		atlas_name = "textures/doom_portrait_atlas"
	},
	skyrim = {
		panel = nil
	},
	boi = {
		panel = nil,
		atlas_name = "textures/boi_atlas",
		hud_scale = 0.5,
		max_hearts = 8,
		hearts_x = 570,
		hearts_y = 24,
		max_per_row = 4,
		heart_size = 32,
		text_x = 172,
		coins_y = 8,
		bombs_y = 19,
		keys_y = 30,
		font_size = 12
	},
	destiny = {
		panel = nil,
		RANKUP_HEIGHT = 200,
		ROTATOR_SIZE_MUL = 1.25,
		ORANGE_W = 1280,
		ORANGE_H = 200,
		STRIPE_H = 500,
		STRIPE_ANGLE = 60,
		EMBLEM_W = 320,
		EMBLEM_H = 320,
		BLUE_STRIPE_H = 10,
		stripe_texture = "textures/destiny_stripe",
		orange_stripe_texture = "textures/destiny_orange_stripe",
		STRIPE_S_SCALE = 0.5,
		STRIPE_M_SCALE = 0.66,
		STRIPE_L_SCALE = 1,
		STRIPE_XL_SCALE = 1.5,
		STRIPE_ALPHA = 0.8,
		FONTSIZE_RANKUP_TITLE = 36,
		FONTSIZE_SEASON_TITLE = 22,
		FONTSIZE_RANK_TITLE = 22,
		RANKUP_INFOBOX_ALPHA = 0.9,
		RANKUP_INFOBOX_DIV_ALPHA = 0.8,
		RANKUP_INFOBOX_DIV_H = 2,
		RANKUP_INFOBOX_DIV_W = 100,
		RANKUP_INFOBOX_W = 300,
		RANKUP_INFOBOX_X = 50,
		RANK_KERN = 24,
		RANKUP_TITLE_W = 340,
		RANKUP_TITLE_H = 64,
		RANK_TITLE_BG_ALPHA = 0.5,
		frame_square_texture = "textures/destiny_frame_square",
		frame_diamond_texture = "textures/destiny_frame_diamond",
		FRAME_ALPHA = 0.25,
		FRAME_DIAMOND_W = 300,
		FRAME_DIAMOND_H = 300,
		FRAME_SQUARE_W = 224,
		FRAME_SQUARE_H = 224,
		skybox_texture = "textures/destiny_rankup_bg",
		crucible_texture = "textures/destiny_crucible",
		rotator_texture_1 = "textures/destiny_rotator_1",
		rotator_texture_2 = "textures/destiny_rotator_2",
		rotator_texture_3 = "textures/destiny_rotator_2",
		ranks_atlas = "textures/destiny_ranks",
		RANKS_SIZE = 180,
		RANK_ICON_W = 180,
		RANK_ICON_H = 180,
		ROTATOR_SIZE_1 = 1280,
		ROTATOR_SIZE_2 = 600,
		ROTATOR_SIZE_3 = 400,
		ROTATOR_ALPHA_1 = 0.3,
		ROTATOR_ALPHA_2 = 0.4,
		ROTATOR_ALPHA_3 = 0.5,
		ROTATOR_SPEED_1 = 0.7,
		ROTATOR_SPEED_2 = 1,
		ROTATOR_SPEED_3 = 2,
		get_rank = function(valor)
			local max_rank = 0
			local all_ranks = {
				[0] = {
					name = "Guardian I",
					icon = 1,
					id = 1
				},
				[10] = {name="Guardian II",icon=1,id=2},
				[25] = {name="Guardian III",icon=1,id=3},
				[50] = {name="Brave I",icon=1,id=4},
				[110] = {name="Brave II",icon=1,id=5},
				[215] = {name="Brave III",icon=1,id=6},
				[350] = {name="Heroic I",icon=2,id=7},
				[420] = {name="Heroic II",icon=2,id=8},
				[550] = {name="Heroic III",icon=2,id=9},
				[700] = {name="Fabled I",icon=3,id=10},
				[790] = {name="Fabled II",icon=3,id=11},
				[940] = {name="Fabled III",icon=3,id=12},
				[1150] = {name="Mythic I",icon=4,id=13},
				[1280] = {name="Mythic II",icon=4,id=14},
				[1510] = {name="Mythic III",icon=4,id=15},
				[1800] = {name="Legend",icon=5,id=16},
				[2000] = {name="Max Valor Rank",icon=5,id=27}
			}
			for valor_threshold,rank_data in pairs(all_ranks) do 
				if valor_threshold <= valor then 
					if valor_threshold > max_rank then 
						max_rank = valor_threshold
					end
				end
			end
			
			--[[
			
			Guardian I	0 - 9	10
			Guardian II	10 - 24	15
			Guardian III25 - 49	25
			Brave I		50 - 109	60
			Brave II	110 - 214	105
			Brave III	215 - 349	135
			Heroic I	350 - 419	70
			Heroic II	420 - 549	130
			Heroic III	550 - 699	150
			Fabled I	700 - 789	90
			Fabled II	790 - 939	150
			Fabled III	940 - 1149	210
			Mythic I	1150 - 1279	130
			Mythic II	1280 - 1509	230
			Mythic III	1510 - 1799	290
			Legend 1800 - 2000	200
			
			--]]
			
			return all_ranks[max_rank] or all_ranks[0]
		end,
		get_rect = function(rank) --rank must be 1-5
			local size = MHP._huds.destiny.RANKS_SIZE
			return {0 * size,(rank - 1) * size,size,size}
		end
	},
	rocketleague = {
		panel = nil,
		PANEL_W = 440,
		PANEL_H = 440,
		BOOST_LABEL_SHADOW_OFFSET = 4,
		BOOST_LABEL_ANGLE = 2.5,
		boost_1_texture = "textures/rocketleague_boost_static",
		boost_2_texture = "textures/rocketleague_boost_radial",
		SCALE = 0.5,
		BOOST_1_X = -16,
		BOOST_1_Y = 18,
		BOOST_X = -200,
		BOOST_Y = -200,
		BOOST_ANGLE = 45,
		BOOST_FONT_SIZE = 64,
		BOOST_LABEL_X = -2,
		BOOST_LABEL_Y = 2,
		BOOST_RANGE = 5/8	
	},
	ftl = {
		panel = nil,
		health_threshold_low = 2/3,
		health_threshold_empty = 0.25,
		name_max_len = 7,
		races = {
			human = {
				row = 1,
				variations = 6
			},
			zoltan = {
				row = 2,
				variations = 5
			},
			engi = {
				row = 3,
				variations = 1
			},
			rock = {
				row = 4,
				variations = 3
			},
			mantis = {
				row = 5,
				variations = 5
			},
			crystal = {
				row = 6,
				variations = 4
			},
			lanius = {
				row = 7,
				variations = 4
			}
		},
		crew_icon_size = 56, --rect only
		atlas_name = "textures/ftl_race_atlas",
		get_rect = function(race)
			local icon_size = MHP._huds.ftl.crew_icon_size
			local variations
			if not (race and MHP._huds.ftl.races[tostring(race)]) then 
				local i = math.random(7)
				local j = 0
				for _race,_ in pairs(MHP._huds.ftl.races) do 
					j = j + 1
					if j == i then
						race = _race
						break
					end
				end
			end
			if race then 
				local race_data = MHP._huds.ftl.races[tostring(race)]
				variations = variations or race_data.variations
				
				local column = 1
				if variations > 1 then 
					column = math.random(variations)
				end
				return {(column - 1) * icon_size,(race_data.row - 1) * icon_size,icon_size,icon_size}
			end
			return {0,0,icon_size,icon_size}
		end,
		font_size = 6,
		scale = 1.5,
		hud_x = 108,
		hud_y = 200,
		teammate_w = 60,
		teammate_h = 20,
		health_x = -5,
		health_y = -5,
		health_w = 30,
		health_h = 3,
		teammate_margin_v = 3,
		icon_x = 4,
		icon_y = 2,
		icon_size = 16,
		name_x = 25,
		name_y = 4
	},
	misc = {
		panel = nil
	}
}

MHP._fonts = {
	tf2 = "fonts/tf2",
	tf2_build = "fonts/tf2_build",
	hl2_icons = "fonts/hl2",
	hl2_text = "fonts/myriad_pro",
	hotline = "fonts/retro_computer",
	hotline_combo = "fonts/justice",
	fallout = "fonts/monofonto",
	minecraft = "fonts/minecraftia",
	eurostile = "fonts/font_eurostile",
	eurostile_ext = "fonts/font_eurostile_ext", --included in pd2 base game 
	gta = "fonts/pricedown",
	gta_outline = "fonts/pricedown_outline",
	stardew_clock = "fonts/stardew",
	stardew_money = "fonts/stardew_thick",
	doom = "fonts/upheaval",
	destiny_bold = "fonts/grotesk_bold",
	destiny_normal = "fonts/grotesk_normal",
	destiny_serif = "fonts/cromwell_nf",
	ftl = "fonts/coderscrux"
}

function MHP.interp_colors(one,two,percent) --interpolates colors based on a percentage
--percent is [0,1]
	percent = math.clamp(percent,0,1)
	
--color 1
	local r1 = one.red
	local g1 = one.green
	local b1 = one.blue
	local a1 = one.alpha
	
--color 2
	local r2 = two.red
	local g2 = two.green
	local b2 = two.blue
	local a2 = two.alpha

--delta
	local r3 = r2 - r1
	local g3 = g2 - g1
	local b3 = b2 - b1
	local a3 = a2 - a1
	
	return Color(r1 + (r3 * percent),g1 + (g3 * percent), b1 + (b3 * percent)):with_alpha(a1 + (a3 * percent))
end

MHP.color_data = {
	fallout = Color(32/255,1,128/255),
	hlm_1 = Color(1,1,1),
	hlm_2 = Color(0,1,1),
	hlm_3 = Color(1,0,1),
	hl2_yellow = Color("FFD040"),
	hl2_orange = Color("FFA000"),
	tf2_grey = Color("363331"),
	tf2_grey_light = Color("7d7a78"),
	tf2_cream = Color("ece3cb"),
	xcom_blue = Color("4db9d5"),
	xcom_yellow = Color("dab900"),
	portal_blue = Color("37a2ff"),
	portal_orange = Color("ff9437"),
	gta_green = Color(0,0.25,0),
	stardew_brown = Color("1f121c"), --dark/"black" text
	stardew_red = Color("840002"),
	stardew_shadow = Color("dd9751"),
	stardew_bar_full = Color.green,
	stardew_bar_low = Color.yellow,
	stardew_bar_empty = Color.red,
	doom_red = Color(0.3,0,0),
	destiny_orange = Color("cf4a1f"), --crucible orange
	destiny_blue = Color("5bcadf"), --powder blue
	rocketleague_orange = Color("fd6500"),
	ftl_bar_full = Color.green,
	ftl_bar_low = Color.yellow,
	ftl_bar_empty = Color.red
}

MHP.color_strobes = {
	hotline_miami = {
		raw = { MHP.color_data.hlm_1,MHP.color_data.hlm_2,MHP.color_data.hlm_3 },
		processed = {}
	}
}

local strobe_size = 25

for name,item in pairs(MHP.color_strobes) do
	local raw = item.raw or {}
	for i,color_1 in ipairs(raw) do 
		local color_2
		if i < #raw then
			color_2 = raw[i + 1]
		else
			color_2 = raw[1]
		end
		for i=1,strobe_size do 
			table.insert(item.processed,MHP.interp_colors(color_1,color_2,i/strobe_size))
		end
	end
end

MHP._waits = 0

MHP.enemy_values = {
	civilian = {
		score = -25,
		valor = nil
	},
	civilian_female = {
		score = -25,
		valor = nil
	},
	sniper = {
		score = 3,
		valor = 10
	}, --sniper
	shield = {
		score = 5,
		valor = 10
	}, --shield
	phalanx_minion = {
		score = 5,
		valor = 20
	}, --winters shield
	phalanx_vip = {
		score = 100,
		valor = 1000
	}, --winters
	medic = {
		score = 6,
		valor = 15
	}, --medic
	taser = {
		score = 7,
		valor = 15
	}, --taser
	spooc = {
		score = 10,
		valor = 10
	}, --cloaker 
	shadow_spooc = {
		score = 20,
		valor = 500
	}, --cloaker 
	tank = {
		score = 12,
		valor = 50
	}, --dozer
	tank_hw = {
		score = 12,
		valor = 200
	}, --headless dozer
	tank_medic = {
		score = 12,
		valor = 120
	},
	tank_mini = {
		score = 12,
		valor = 200
	},
	swat_turret = {
		score = 16,
		valor = 100
	},
	security_undominatable = {
		score = -1000,
		valor = nil
	}, --garrett
	mute_security_undominatable = {
		score = -1000,
		valor = nil
	}, --also garrett i guess
	security = {
		score = 1,
		valor = 5
	},
	gensec = {
		score = 1,
		valor = 5
	},
	cop = {
		score = 1,
		valor = 5
	},
	cop_scared = {
		score = 1,
		valor = 5
	},
	cop_female = {
		score = 1,
		valor = 5
	},
	fbi = {
		score = 1,
		valor = 10
	},
	swat = {
		score = 1,
		valor = 10
	},
	heavy_swat = {
		score = 1,
		valor = 10
	},
	heavy_swat_sniper = {
		score = 1,
		valor = 10
	},
	fbi_swat = {
		score = 1,
		valor = 10
	},
	fbi_heavy_swat = {
		score = 1,
		valor = 10
	},
	city_swat = {
		score = 1,
		valor = 10
	},
	gangster = {
		score = 1,
		valor = 10
	},
	biker = {
		score = 1,
		valor = 10
	},
	biker_escape = {
		score = 1,
		valor = 10
	},
	mobster = {
		score = 1,
		valor = 10
	},
	mobster_boss = {
		score = 100,
		valor = 1000
	}, --commissar fucks again asshole
	biker_boss = {
		score = 100,
		valor = 1500
	}, --the biker heist day 2 boss 
	chavez_boss = {
		score = 100,
		valor = 900
	}, --panic room man
	hector_boss = {
		score = 100,
		valor = 900
	}, 
	hector_boss_no_armor = {
		score = 100,
		valor = 900
	},
	bolivian = {
		score = 1,
		valor = 10
	},
	bolivian_indoors = {
		score = 1,
		valor = 10
	},
	bolivian_indoors_mex = {
		score = 1,
		valor = 10
	},
	drug_lord_boss = {
		score = 100,
		valor = 1000
	}, --sosa
	drug_lord_boss_stealth = {
		score = 100,
		valor = 1000
	}, --also sosa
	
	deathvox_guard = {
		score = 1,
		valor = 10
	},
	deathvox_gman = {
		score = 1,
		valor = 50
	},
	deathvox_lightar = {
		score = 1,
		valor = 20
	},
	deathvox_lightshot = {
		score = 1,
		valor = 20
	},
	deathvox_heavyar = {
		score = 1,
		valor = 20
	},
	deathvox_heavyshot = {
		score = 1,
		valor = 20
	},
	deathvox_shield = {
		score = 5,
		valor = 100
	},
	deathvox_medic = {
		score = 6,
		valor = 100
	},
	deathvox_taser = {
		score = 7,
		valor = 100
	},
	deathvox_tank = {
		score = 12,
		valor = 150
	},
	deathvox_cloaker = {
		score = 10,
		valor = 100
	},
	deathvox_sniper = {
		score = 3,
		valor = 100
	},
	deathvox_greendozer = {
		score = 12,
		valor = 150
	},
	deathvox_blackdozer = {
		score = 12,
		valor = 150
	},
	deathvox_lmgdozer = {
		score = 12,
		valor = 150
	},
	deathvox_medicdozer = {
		score = 12,
		valor = 150
	},
	deathvox_guarddozer = {
		score = 12,
		valor = 150
	},
	deathvox_grenadier = {
		score = 7,
		valor = 100
	},
	deathvox_cop_pistol = {
		score = 1,
		valor = 20
	},
	deathvox_cop_smg = {
		score = 1,
		valor = 20
	},
	deathvox_cop_revolver = {
		score = 1,
		valor = 20
	}, 
	deathvox_cop_shotgun = {
		score = 1,
		valor = 20
	},
	deathvox_fbi_rookie = {
		score = 1,
		valor = 20
	},
	deathvox_fbi_hrt = {
		score = 1,
		valor = 20
	},
	deathvox_fbi_veteran = {
		score = 1,
		valor = 20
	},
	
	--RESTORATION MOD VALUES
	tank_green = {
		score = 12,
		valor = 50
	},
	tank_black = {
		score = 12,
		valor = 50
	},
	tank_skull = {
		score = 12,
		valor = 50
	},
	tank_biker = {
		score = 12,
		valor = 50
	},
	boom = {
		score = 6,
		valor = 50
	},
	boom_summers = {
		score = 12,
		valor = 500
	},
	taser_summers = {
		score = 12,
		valor = 500
	},
	medic_summers = {
		score = 12,
		valor = 500
	},
	rboom = {
		score = 12,
		valor = 50
	},
	heavy_swat_sniper = {
		score = 3,
		valor = 20
	},
	weekend_dmr = {
		score = 2,
		valor = 20
	},
	tank_titan = {
		score = 24,
		valor = 100
	},
	tank_titan_assault = {
		score = 24,
		valor = 100
	},
	spring = {
		score = 50,
		valor = 600
	},
	summers = {
		score = 50,
		valor = 600
	},
	omnia_lpf = {
		score = 3,
		valor = 50
	},
	phalanx_minion_assault = {
		score = 5,
		valor = 100
	},
	spooc_titan = {
		score = 12,
		valor = 100
	},
	taser_titan = {
		score = 12,
		valor = 100
	},
	autumn = {
		score = 50,
		valor = 600
	}
}




function MHP:Init()
	self._ws = managers.gui_data:create_fullscreen_workspace()
	self._panel = self._ws and self._ws:panel()
	self:CreateHUD()
	if BeardLib then 
		BeardLib:AddUpdater("MHP_update",callback(MHP,MHP,"UpdateHUD"))
	end
end

function MHP:CreateHUD()
	local hud = self._panel
	if not (hud and alive(hud)) then 
		self:log("MHP: Error creating master HUD panel")
		return
	end
	hud:hide()
	
	local hlm_score = self:_create_hotline_miami(hud)
	local vats = self:_create_vats(hud)
	local minecraft = self:_create_hud_minecraft(hud)
	local tf2_hud = self:_create_hud_tf2(hud)
	local hl2_hud = self:_create_hud_hl2(hud)
	local lego_hud = self:_create_hud_lego(hud)
	local pogo_hud = self:_create_hud_pogo(hud)
	local xcom_hud = self:_create_hud_xcom(hud)
	local portal_hud = self:_create_hud_portal(hud)
	local gta_hud = self:_create_hud_gta(hud)
	local stardew_hud = self:_create_hud_stardew(hud)
	local doom_hud = self:_create_hud_doom(hud)
	local katamari_hud = self:_create_hud_katamari(hud)
	local boi_hud = self:_create_hud_boi(hud)
	local destiny_hud = self:_create_destiny_hud(hud)
	local rocketleague = self:_create_hud_rocketleague(hud)
	local ftl = self:_create_ftl(hud)
	local misc = self:_create_misc(hud)
end

function MHP:UpdateHUD(t,dt)
--[[
	for name,panel in ipairs(MHP._huds) do 
		--update all subelements of hud appropriately
		local setting = self:GetSetting(name)
		if setting == "none" then
		elseif setting == "hp" then 
		elseif setting == "armor" then 
		elseif setting == "stamina" then 
		elseif setting == "dodge" then 
		elseif setting == "resist" then 
		elseif setting == "crit" then
		end
	end
	--]]
	
	--[[
	local destiny_data = self._huds.destiny
	if alive(destiny_data.panel) then 
		local rankup_master = destiny_data.panel:child("rankup_master")
		local rotator_1 = rankup_master:child("rankup_bound"):child("bg_rotator_1")
		local rotator_2 = rankup_master:child("bg_rotator_2")
		local rotator_3 = rankup_master:child("bg_rotator_3")
		rotator_1:set_rotation(rotator_1:rotation() + (destiny_data.ROTATOR_SPEED_1 * dt))
		rotator_2:set_rotation(rotator_2:rotation() + (destiny_data.ROTATOR_SPEED_2 * dt))
		rotator_3:set_rotation(rotator_3:rotation() + (destiny_data.ROTATOR_SPEED_3 * dt))
	end
	--]]
		
	if not managers.experience:reached_level_cap() then
		self:UpdateInterpolateExperience(t,dt)
		self:UpdateExperience(t,dt)
	end
	
	local player = managers.player:local_player()
	if player and alive(player) then 
		self._panel:show()
		local movement = player:movement()
		
		local state = movement:current_state()
		
		local katamari_data = self._huds.katamari
		if state._moving then 
			if movement:running() then --don't check update interval t, just go every goddamn frame
				self._update_intervals.katamari_t = t				
				self.info.current_katamari = (self.info.current_katamari + 1) % (katamari_data.active_frames)
				katamari_data.panel:child("katamari"):set_image(katamari_data.atlas_name,self.info.current_katamari * katamari_data.rect_w,0,katamari_data.rect_w,katamari_data.rect_h)
			elseif movement:crouching() then 
				if self._update_intervals.katamari_t + (self._update_intervals.katamari) < t then 					
					self._update_intervals.katamari_t = t	
					self.info.current_katamari = (self.info.current_katamari + 1) % (katamari_data.active_frames)
					katamari_data.panel:child("katamari"):set_image(katamari_data.atlas_name,self.info.current_katamari * katamari_data.rect_w,0,katamari_data.rect_w,katamari_data.rect_h)
				end
			elseif self._update_intervals.katamari_t + (self._update_intervals.katamari / 2) < t then
				self._update_intervals.katamari_t = t
				self.info.current_katamari = (self.info.current_katamari + 1) % (katamari_data.active_frames)
				katamari_data.panel:child("katamari"):set_image(katamari_data.atlas_name,self.info.current_katamari * katamari_data.rect_w,0,katamari_data.rect_w,katamari_data.rect_h)
			end
		elseif self._update_intervals.katamari_t + self._update_intervals.katamari < t then
			self._update_intervals.katamari_t = t
			self.info.current_katamari = (self.info.current_katamari + 1) % katamari_data.idle_frames
			katamari_data.panel:child("katamari"):set_image(katamari_data.atlas_name,self.info.current_katamari * katamari_data.rect_w,1 * katamari_data.rect_h,katamari_data.rect_w,katamari_data.rect_h)
		end
		self:SetStamina(movement._stamina,movement:_max_stamina())
		
		if self._update_intervals.dodge_t < t then 
			self._update_intervals.dodge_t = t + self._update_intervals.dodge
			self.info.dodge = (managers.player:skill_dodge_chance(player:movement():running(),player:movement():crouching(),player:movement():zipline_unit(),false,managers.blackmarket:_get_concealment_from_local_player()) + managers.player:body_armor_value("dodge")) or self.info.dodge
		end
		if self._update_intervals.crit_t < t then 
			self._update_intervals.crit_t = t + self._update_intervals.crit
			self.info.crit = managers.player:critical_hit_chance() or self.info.crit
		end
		if self._update_intervals.resist_t < t then 
			self._update_intervals.resist_t = t + self._update_intervals.resist
			self.info.resist = (1 - managers.player:damage_reduction_skill_multiplier("bullet")) or self.info.resist
		end
		local equipped_weapon = player and player:inventory() and player:inventory():equipped_unit() and player:inventory():equipped_unit():base()
		if equipped_weapon then
			if self._update_intervals.weapon_t < t then 
				self._update_intervals.weapon_t = t + self._update_intervals.weapon
				local stats = equipped_weapon._current_stat_indices
				local weapon_id = equipped_weapon.get_name_id and equipped_weapon:get_name_id() or equipped_weapon._name_id or ""
				if stats and type(stats) == "table" then 
					self.info.damage = stats.damage or self.info.damage
					self.info.spread = stats.spread or self.info.spread
				elseif equipped_weapon and weapon_id then
					self.info.damage = equipped_weapon._damage or self.info.damage
					stats = tweak_data.weapon[weapon_id]
					self.info.spread = stats and stats.stats.spread or self.info.spread
	--				self.info.spread = equipped_weapon._spread or self.info.spread
				end
				--managers.player:local_player():inventory():equipped_unit():base()._spread = 10
				local weapon_name
				if player:inventory():equipped_selection() == 1 then 
					weapon_name = managers.blackmarket:equipped_secondary().custom_name			
				else
					weapon_name = managers.blackmarket:equipped_primary().custom_name
				end
				if weapon_name then 
					self.info.weapon_name = weapon_name or self.info.weapon_name
				else 
					weapon_name = managers.weapon_factory:get_weapon_name_by_weapon_id(weapon_id)
					self.info.weapon_name = weapon_name or self.info.weapon_name
				end
			end
		end
		
		local has_set_doomface = false

		if player:character_damage()._invulnerable or player:character_damage()._god_mode then 
			has_set_doomface = true
			self:SetDoomFace("GOD")
			self._update_intervals.doomface_t = t + self._update_intervals.doomface
		end

		if state.shooting_t and (t - state.shooting_t >= 2) then 
			self:SetDoomFace("EVL")
			self._update_intervals.doomface_t = t + self._update_intervals.doomface
			has_set_doomface = true
		end
			
		
		for i,hit_indicator in ipairs(self.info.hit_indicators) do 
			if hit_indicator.start_t + self.settings.hit_indicator_duration > t then 
				table.remove(self.info.hit_indicators,i)
			elseif not has_set_doomface then 
				--always use latest hit indicator for doom's indicator
				
				local angle_threshold = 45
				local player_aim = player:movement():m_head_rot():yaw() or 0
		
				if hit_indicator.source ~= player then 
					if hit_indicator.damage_origin then 
						local angle_to = 90 + MHP.angle_from(player:position(),hit_indicator.damage_origin) - player_aim
						if angle_to > angle_threshold then 
							self:SetDoomFace("KILL_TR")
							has_set_doomface = true
						elseif angle_to < -angle_threshold then 
							self:SetDoomFace("KILL_TL")
							has_set_doomface = true
						else 
							self:SetDoomFace("KILL")
						end
					end
				end
			end
		end

		if (not has_set_doomface) and (self._update_intervals.doomface_t < t) then 
			self._update_intervals.doomface_t = t + self._update_intervals.doomface
			local r_doomface_direction = math.random()
			if r_doomface_direction < 0.33 then 
				self:SetDoomFace("TL",nil,true)
			elseif r_doomface_direction > 0.66 then 
				self:SetDoomFace("TR",nil,true)
			else
				self:SetDoomFace("ST",nil,true)
			end
		end
	else
		self._panel:hide()
	end
	

	if self._update_intervals.money_t < t then 
		self._update_intervals.money_t = t + self._update_intervals.money
		--[[
		local money = 0
		for _,payout in pairs(managers.money:get_payouts()) do 
			money = money + payout
		self:SetMoney(money)
		end
		--]]
		self:SetMoney(managers.money:get_potential_payout_from_current_stage())
	end
	
	if self.info.hlm_combos.end_t and (self.info.hlm_combos.end_t < t) then 
		self.info.hlm_combos.end_t = nil
		if self.info.hlm_combos.count >= self._huds.hotline_miami.min_combo then 
			self:AnimateHotlineMiamiCombo(self.info.hlm_combos.count)
		end
		self.info.hlm_combos.count = 0
	end
	
	local d2_data = self._huds.destiny
	if alive(d2_data.panel) then 
		local d2 = d2_data.panel:child("rankup_master")
		local rotator_2 = d2:child("bg_rotator_2")
		local rotator_3 = d2:child("bg_rotator_3")
		rotator_2:set_rotation(rotator_2:rotation() + (d2_data.ROTATOR_SPEED_2 * dt))
		rotator_3:set_rotation(rotator_3:rotation() + (d2_data.ROTATOR_SPEED_3 * dt))
	end
	
	self:UpdateClock(t,dt,os.time())
	
	self:UpdateInterpolateMoney(t,dt)
	self:UpdateMoney(t,dt)
	self:UpdateInterpolateScore(t,dt)
	self:UpdateVATS()
	self:AnimateTF2LowAmmo(t,dt)
	self:AnimateTF2LowHealth(t,dt)
	self:AnimateHotlineMiamiScore(t,dt)
	self:AnimateStardewHealth(t,dt)
	self:AnimateStardewMoney(t,dt)
	self:UpdateXCOMBox(t,dt)
	self:UpdateAnimate(t,dt)
end

function MHP:UpdateClock(t,dt,epoch)
	self:SetGTAClock(epoch)
	self:SetStardewClock(epoch,t)
	self:SetStardewDate(epoch)
end

function MHP:UpdateInterpolateScore(t,dt)
	if self.settings.interpolate_score then 
	--[[
		local start_score = self.info.score_interp_start
--		local current_score = self.info.score_interp
		local true_score = self.info.score
		local start_t = self.info.score_interp_t

		local progress = t - start_t
		
		local delta = true_score - start_score
		local interp_duration = self.settings.interp_duration
		
		local d_abs = math.abs(delta) --remember, when someone is being negative, d_abs on the haters
		if d_abs > 0 then 
			
			if (d_abs < 1) or (progress > interp_duration) then 
				self.info.score_interp = true_score
			else
				self.info.score_interp = start_score + (delta * progress / interp_duration)
			end
		else
			self.info.score_interp_start = true_score
			self.info.score_interp = true_score
		end
		--]]
	end
end

function MHP:UpdateInterpolateExperience(t,dt)
	local start_xp = self.info.xp_interp_start
	local true_xp = self.info.xp
	local start_t = self.info.xp_interp_t

	local progress = t - start_t
		
	local delta = true_xp - start_xp
	local interp_duration = self.settings.interp_duration
	local d_abs = math.abs(delta) --remember, when someone is being negative, d_abs on the haters
	if d_abs > 0 then 
		
		if (d_abs < 1) or (progress > interp_duration) then 
			self.info.xp_interp = true_xp
		else
			self.info.xp_interp = start_xp + (delta * progress / interp_duration)
		end
	else
		self.info.xp_interp_start = true_xp
		self.info.xp_interp = true_xp
	end
end

function MHP:UpdateExperience(t,dt)
	local xm = managers.experience
	local data = xm:next_level_data()
	local current_total = data.current_points + xm:mission_xp()
	
	if self.info.xp ~= current_total then
		self.info.xp_interp = self.info.xp
		self.info.xp = current_total
		self.info.interp_t = t
	end

	local xp_interp = self.info.xp_interp
	local lvlup_threshold = data.points
		
	self:SetMinecraftXP(xp_interp,lvlup_threshold)
end

function MHP:UpdateInterpolateMoney(t,dt)
	local start_money = self.info.money_interp_start
	local true_money = self.info.money
	local start_t = self.info.money_interp_t

	local progress = t - start_t
		
	local delta = true_money - start_money
	local interp_duration = self.settings.interp_duration
	local d_abs = math.abs(delta)
	if d_abs > 0 then 
		
		if (d_abs < 1) or (progress > interp_duration) then 
			self.info.money_interp_start = true_money
			self.info.money_interp = true_money
		else
			self.info.money_interp = start_money + (delta * progress / interp_duration)
		end
	else
		self.info.money_interp_start = true_money
		self.info.money_interp = true_money
	end
end

function MHP:UpdateMoney(t,dt)
	local money = self.info.money_interp
	self:SetStardewMoney(money)
	self:SetGTAMoney(money)
	self:SetBOICoins(money)
	--todo animate
end

function MHP:GetSetting(name)
	return self.settings[tostring(name)]
end

function MHP:SetValue(name,value) -- generic; not really used
	self.info[tostring(name)] = value
end

function MHP:GetValue(name,fallback)
	local value = self.info[tostring(name)]
	if value == nil then 
		return fallback
	end
	return value
end

function MHP:SetHealth(current,total)
	self:SetDoomHealth(current,total)

	self.info.health_total = total or self.info.health_total
	self.info.health_current = current
	
	self:SetBOIHealth(current,total)
	self:SetMinecraftHealth(current,total)
	self:SetHL2Health(current,total)
	self:SetTF2Health(current,total)
	self:SetStardewHealth(current,total)
	
end

function MHP:SetArmor(current,total)
	self.info.armor_total = total or self.info.armor_total
	self.info.armor_current = current or self.info.armor_current
	
	self:SetHL2Suit(current,total)
	self:SetMinecraftArmor(current,total)
	self:SetDoomArmor(current,total)
end

function MHP:SetGrenadesAmount(data)
	if data and data.amount then 
		self:SetBOIBombs(data.amount)
	end
end

function MHP:SetDeployableAmount(data)
	if data and data.amount then 
		self:SetBOIKeys(data.amount)
	end
end

function MHP:SetStamina(current,total)
	self.info.stamina_current = current or self.info.stamina_current
	self.info.stamina_max = total or self.info.stamina_max
	
	self:SetMinecraftHunger(current,total)
	self:SetStardewEnergy(current,total)
	self:SetRocketLeagueBoost(current,total)
end

function MHP:SetTeammateName(i,name)
	MHP:SetFTLTeammateName(i,name)
end

function MHP:AddTeammate(i)
	MHP:AddFTLTeammate(i)
end

function MHP:RemoveTeammate(i,...)
	MHP:RemoveFTLTeammate(i)
end

function MHP:SetAmmo(type, max_clip, current_clip, current_left, max, weapon_panel)
	local slot = managers.player:local_player() and managers.player:local_player():inventory():equipped_selection()
	if (type == "primary" and slot == 2) or (type == "secondary" and slot == 1) then 
		self.info.current_clip = current_clip or self.info.current_clip
		self.info.max_clip = max_clip or self.info.max_clip
		local true_reserves = math.clamp(current_left - current_clip,0,current_left)
		
		self:SetTF2Ammo(current_clip,true_reserves,max_clip)
		self:SetDoomAmmo(current_clip,true_reserves,max_clip)
	end
--	self.info.health_current = current or self.info.health_current
end

function MHP:SetMoney(amount)
	if amount and self.info.money ~= amount then
		self.info.money_interp_start = self.info.money_interp
		self.info.money = amount
		self.info.money_interp_t = Application:time()
	end
	
end

function MHP:AddScore(n)
	n = tonumber(n)
	if n then 
		self:SetScore(self.info.score + n)
	end
end

function MHP:GetInterpolatedScore(t)
	t = t or Application:time()
	local i_t = self.info.score_interp_t
	local d_t = t - i_t
	local duration = self.info.score_interp_duration
	local s = self.info.score
	if d_t > duration then 
		self.info.score_interp = s
		return s
	end
	local i_s = self.info.score_interp
	local d_s = s - i_s
	return i_s + (d_s * d_t / duration)
end

function MHP:SetScore(n)
	if self.settings.interpolate_score then
--		self.info.score_interp_start = self.info.score_interp
		self.info.score_interp = self.info.score
		self.info.score_interp_t = Application:time()
	end
	self.info.score = n
end

function MHP:GetScore()
	if self.settings.interpolate_score then
		return self:GetInterpolatedScore()
	else
		return self.info.score
	end
end

function MHP:RegisterPlayerHitIndicator(damage_origin,damage_type,fixed_angle)
	table.insert(self.info.hit_indicators,{damage_origin = damage_origin,damage_type = damage_type,fixed_angle = fixed_angle,start_t = Application:time()})
end

function MHP.angle_from(a,b,c,d) -- converts to angle with ranges (-180 , 180); for result range 0-360, do +180 to result
--mvector3.angle() is a big fat meanie zucchini;
	a = a or "nil"
	b = b or "nil"
	c = c or "nil"
	d = d or "nil"
	local function do_angle(x1,y1,x2,y2)
		local angle = 0
		local x = x2 - x1 --x diff
		local y = y2 - y1 --y diff
		if x ~= 0 then 
			angle = math.atan(y / x) % 180
			if y == 0 then 
				if x > 0 then 
					angle = 180 --right
				else
					angle = 0 --left 
				end
			elseif y > 0 then 
				angle = angle - 180
			end
		else
			if y > 0 then
				angle = 270 --up
			else
				angle = 90 --down
			end
		end
		
		return angle
	end
	local vectype = type(Vector3())
	if (type(a) == vectype) and (type(b) == vectype) then  --vector pos diff
		return do_angle(a.x,a.y,b.x,b.y)
	elseif (type(a) == "number") and (type(b) == "number") and (type(c) == "number") and (type(d) == "number") then --manual x/y pos diff
		return do_angle(a,b,c,d)
	else
		return
	end
end

function MHP:AnimateWait(duration,done_cb,...)
	self._waits = self._waits + 1
	self:animate(self._waits,self.animate_wait,done_cb,duration,...)
	return self._waits
end

function MHP:animate(target,func,done_cb,...)
	if target then 
		if type(func) == "function" then 
		elseif type(self[tostring(func)]) == "function" then
			func = self[tostring(func)]
		else
			--error!
			return
		end
		if (type(target) == "number") or alive(target) then
			self._animate_targets[tostring(target)] = {
				func = func,
				target = target,
				start_t = Application:time(),
				done_cb = done_cb,
				params = {
					...
				}
			}
		end
	end
end

function MHP:animate_stop(name,do_cb)
	local item = self._animate_targets[tostring(name)]
	if item and do_cb and (type(item.done_cb) == "function") then 
		return item.done_cb(item.target,unpack(item.params))
	end
end

function MHP:UpdateAnimate(t,dt)
	for id,data in pairs(self._animate_targets) do 
		if data and data.target and ((type(data.target) == "number") or alive(data.target)) then 
			local result = data.func(data.target,t,dt,data.start_t,unpack(data.params or {}))
			if result then 
				if type(data.done_cb) == "function" then 
					local done_cb = data.done_cb
					local target = data.target
					local params = data.params
					self._animate_targets[id] = nil
					done_cb(target,unpack(params))
--					data.done_cb(data.target,unpack(data.params))
				else
					self._animate_targets[id] = nil
				end
			end
		else
			self._animate_targets[id] = nil
		end
	end
end

function MHP:AddDestinyValor(amount,override)
	amount = tonumber(amount)
	if amount then 
		if override then 
			self.info.valor = amount
		else
			self.info.valor = self.info.valor + amount
		end
	end
	return self.info.valor
end

function MHP:GetDestinyValor()
	return self.info.valor
end

function MHP:OnKillshot(killed_unit,variant,headshot,weapon_id)

	if not alive(killed_unit) then return end
	
	local base = killed_unit and killed_unit:base()
	local unit_type = base and tostring(base._tweak_table)
	local unit_data = self.enemy_values[unit_type] or {}
	local score_gain = unit_data.score
	local valor_gain = unit_data.valor
	if valor_gain then 
		local valor = MHP:AddDestinyValor(valor_gain * 0.5)
		local valor_data = self._huds.destiny.get_rank(valor)
		if valor_data and valor_data.id > self.info.valor_rank_id then 
			self.info.valor_rank_id = valor_data.id
			self:StartDestinyRankup(valor_data)
		end
	end
	if score_gain then 
	
		Hooks:Call("MHP_SetScore_Builtin",score_gain * 100)
		if score_gain > 0 then 
			self.info.hlm_combos.count = self.info.hlm_combos.count + 1
			
			self.info.hlm_combos.end_t = Application:time() + self._huds.hotline_miami.combo_time
			
			self.info.hlm_combos.last_pos = killed_unit:position()
		end
		
	end
end

Hooks:Register("MHP_SetScore_Builtin")
Hooks:Add("MHP_SetScore_Builtin","MHP_OnAddScore",function(score)
	MHP:AddScore(score)
end)


-- HOTLINE MIAMI

function MHP:_create_hotline_miami(hud)
	local hotline_hud = hud:panel({
		name = "hotline_miami"
	})
	self._huds.hotline_miami.panel = hotline_hud
	local data = self._huds.hotline_miami
	local scale = data.scale
	local BOX_W = data.BOX_W * scale
	local BOX_H = data.BOX_H * scale
	local FONT_SIZE = data.FONT_SIZE * scale
	
	
	local combo_text = hotline_hud:text({
		name = "combo_text",
		text = "2x combo",
		x = 0, ---1000,
		y = 0,
		align = "center",
		vertical = "top",
		font = self._fonts.hotline_combo,
		font_size = data.COMBO_FONT_SIZE,
		color = Color.white,
		layer = 4,
		visible = false
	})
	
	local combo_text_shadow = hotline_hud:text({
		name = "combo_text_shadow",
		text = "2x combo",
		x = 0, ---1000,
		y = 0,
		align = "center",
		vertical = "top",
		font = self._fonts.hotline_combo,
		font_size = data.COMBO_FONT_SIZE,
		color = Color.white,
		layer = 4,
		visible = false
	})
	
	
	
	local score = hotline_hud:panel({
		name = "score",
		w = BOX_W,
		h = BOX_H,
		x = hotline_hud:w() - BOX_W,
		y = 160
	})
	local score_box = score:rect({
		name = "score_box",
		color = Color.black,
--		alpha = 0.3,
		layer = 1
	})
	
	local score_label_front = score:text({
		name = "score_label_front",
		text = "12020pts",
		x = -16,
		y = 4, --self._huds.hotline_miami.v_offset,
		rotation = 15,
		align = "center",
		vertical = "top",
		font = self._fonts.hotline,
		font_size = FONT_SIZE,
		color = Color.white,
		layer = 3,
		visible = true
	})
	local score_label_back = score:text({
		name = "score_label_back",
		text = "12020pts",
		x = 5,
--		align = 'center',
--		y = score_label_front:y() + 15,
		rotation = 15,
		align = "center",
		vertical = "top",
		font = self._fonts.hotline,
		font_size = FONT_SIZE,
		color = Color.white,
		layer = 2,
		visible = true
	})
end

function MHP:AnimateHotlineMiamiScore(t,dt)
	local hlm_data = self._huds.hotline_miami
	if hlm_data and hlm_data.panel and alive(hlm_data.panel) then 
		local score_panel = hlm_data.panel:child("score")
		local label_1 = score_panel:child("score_label_front")
		local label_2 = score_panel:child("score_label_back")
		local max_angle = 10
		local distance = 1.5
		local rot_speed = hlm_data.rot_speed
		local angle = math.sin(t * rot_speed) * max_angle
		label_1:set_rotation(angle)
		label_2:set_rotation(angle)
		label_2:set_position(label_1:x() + (math.sin(t * rot_speed) * distance),label_1:y() + (math.cos(t * rot_speed) * distance))
		
		local col_table = self.color_strobes.hotline_miami.processed
		local col_t = math.floor(t * 10)
		local col_1 = col_table[col_t % #col_table]
		local col_2 = col_table[(col_t + math.floor(#col_table / 2)) % #col_table]
		if col_1 then 
			label_1:set_color(col_1)
		end
		if col_2 then 
			label_2:set_color(col_2)
		end
		
		local score = string.format("%d",self:GetScore()) .. "pts"
		label_1:set_text(score)
		label_2:set_text(score)
	end
end

function MHP:AnimateHotlineMiamiCombo(num) --starts animate
	local data = self._huds.hotline_miami
	local panel = data.panel
	local text = string.upper(string.gsub(data.combo_string,data.combo_macro,num))
	
	local combo = panel:child("combo_text")
	local shadow = panel:child("combo_text_shadow")
	combo:set_text(text)
	shadow:set_text(text)
	
	combo:set_font_size(data.COMBO_FONT_SIZE)
	shadow:set_font_size(data.COMBO_FONT_SIZE)
	
	
	local screen_pos = self._ws:world_to_screen(managers.viewport:get_current_camera(),self.info.hlm_combos.last_pos)
	combo:set_position(screen_pos.x,screen_pos.y)
	shadow:set_position(screen_pos.x,screen_pos.y)
	
	

	combo:show()
	shadow:show()
	self:animate(panel,"animate_hlm_combo",
		function()
			self:animate(combo,"animate_fade_resize_text",Text.hide,0.25,combo:font_size(),0,nil,nil,nil,nil,2)
			self:animate(shadow,"animate_fade_resize_text",Text.hide,0.25,shadow:font_size(),0,nil,nil,nil,nil,2)
		end,
		2,self.info.hlm_combos.last_pos,data.combo_anim_height
	)
end

function MHP.animate_fade_resize_text(o,t,dt,start_t,duration,from_size,to_size,from_alpha,to_alpha,center_x,center_y,power)
	local ratio = (t - start_t) / duration
	local should_end = false
	if ratio >= 1 then 
		should_end = true
		ratio = 1
	end
	ratio = math.pow(ratio,power or 2)
	
	if from_size and to_size then
		o:set_font_size(from_size + ((to_size - from_size) * ratio))
	end
	if from_alpha and to_alpha then 
		o:set_font_size(from_alpha + ((to_alpha - from_alpha) * ratio))
	end
	
	if center_x and center_y then 
		o:set_center(center_x,center_y)
	end
	
	if should_end then 
		return true
	end
end

function MHP.animate_hlm_combo(o,t,dt,start_t,duration,start_pos,d_y,power)
	
	local data = MHP._huds.hotline_miami
	local panel = data.panel
	
	local combo = panel:child("combo_text")
	local shadow = panel:child("combo_text_shadow")
	
	local ratio = (t - start_t) / duration
	local should_end = false
	if ratio >= 1 then 
		ratio = 1
		should_end = true
	end
	ratio = math.pow(ratio,power or 2)
	
	local col_table = MHP.color_strobes.hotline_miami.processed
	local col_t = math.floor(t * 100)
	
	local col_1 = col_table[col_t % #col_table]
	local col_2 = col_table[(col_t + math.ceil(#col_table / 10)) % #col_table]
	if col_1 then 
		combo:set_color(col_1)
	end
	if col_2 then 
		shadow:set_color(col_2)
	end
	
	local distance = data.combo_rot_distance * data.scale
	local rot_speed = data.combo_rot_speed
	
	local viewport_cam = managers.viewport:get_current_camera()
	local aim = viewport_cam:rotation():yaw()
	local my_pos = viewport_cam:position()	
	local angle_from = (180 + aim - MHP.angle_from(start_pos.x,start_pos.y,my_pos.x,my_pos.y)) % 360
	
	if math.abs(90 - angle_from) > 90 then
		combo:set_position(-1000,-1000)
		shadow:set_position(-1000,-1000)
	else
		local screen_pos = MHP._ws:world_to_screen(viewport_cam,start_pos)
		local x_1 = screen_pos.x - (panel:w() / 2)
		local y_1 = screen_pos.y + (d_y * ratio)
		
		combo:set_x(x_1 + (math.sin(t * rot_speed) * distance))
		combo:set_y(y_1 + (math.cos(t * rot_speed) * distance))
		
		shadow:set_x(x_1 - (math.sin(t * rot_speed) * distance))
		shadow:set_y(y_1 - (math.cos(t * rot_speed) * distance))
	end
	
	combo:set_font_size(data.COMBO_FONT_SIZE * (1 + (ratio * 0.5)))
	shadow:set_font_size(data.COMBO_FONT_SIZE * (1 + (ratio * 0.5)))
	
	
	if should_end then 
		return true
	end
end


-- Fallout 3 VATS

function MHP:_create_vats(hud)
	local data = self._huds.vats
	local vats_hud = hud:panel({
		name = "vats"
	})
	self._huds.vats.panel = vats_hud
	
	
	--approximately 128x72 ratio, or 16x9
	
	local function create_box (name)
		local w = 64
		local h = 36
		local h_pad = 16
		local box = vats_hud:panel({
			name = name,
			w = w,
			h = h + h_pad,
			visible = false
		})
		local body_name = box:text({
			name = "body_name",
			text = name,
			font = self._fonts.fallout,
			font_size = 14,
			color = self.color_data.fallout,
			align = "left",
			halign = "grow",
			x = 4
		})
		local bg = box:bitmap({
			name = "bg",
			texture = "textures/vats_bg",
			w = 64,
			h = 36,
			y = h_pad,
			layer = -1,
			visible = true
		})
		local liner = box:bitmap({
			name = "liner",
			texture = "textures/vats_overlay",
			w = 64,
			h = 36,
			y = h_pad,
			layer = 1,
			color = self.color_data.fallout,
			visible = true
		})
		local bar = box:rect({
			name = "bar",
			color = self.color_data.fallout,
			w = 20 + math.random(16),
			h = 5,
			x = data.BAR_X,
			y = 5 + h_pad,
			visible = true
		})
		local label = box:text({
			name = "label",
			text = "69%", --haha nice
			font = self._fonts.fallout,
			font_size = 16,
			color = self.color_data.fallout,
			align = "left",
			x = 4,
			y = 8 + h_pad
		})
		local debug_box = box:rect({
			name = "debug",
			color = Color.red,
			alpha = 0.1,
			visible = false
		})
	end
	
--	create_box("butt")
	
	for _,name in pairs(data.bodies) do 
		create_box(name)
	end
	
end

function MHP:UpdateVATS(t,dt)
	local data = self._huds.vats
	local vats_panel = data.panel
		
	local player = managers.player:local_player()
	if player and alive(player) then 
		local hit_chance = 0
		
		local state = player:movement():current_state()
		
		local fire_position = state:get_fire_weapon_position()
		local fire_direction = state:get_fire_weapon_direction()
		local my_weapon = state._equipped_unit
		local wpn_base = my_weapon:base()
--		local stats = wpn_base._current_stat_indices
--		local spread = stats and stats.spread or 20
		
--		local spread_percent = math.clamp((spread - 4) * 4,0,100) / 100
		
		
		
		local fwd_ray = state and state._fwd_ray
		local aim_unit = fwd_ray and fwd_ray.unit
		local fwd_body
		if alive(aim_unit) and aim_unit:character_damage() and alive(fwd_ray.body) then 
			fwd_body = fwd_ray.body
			self.info.hit = math.clamp((self.info.spread - 1) / 25,0,100)
		else
			self.info.hit = 0
		end
		
		local autoaim = wpn_base:check_autoaim(fire_position,fire_direction,nil,true)
		local unit = autoaim and autoaim.unit
		if alive(unit) and unit:character_damage() then
			local distance_to = math.max(mvector3.distance(player:position(),unit:position()),1)
						
			vats_panel:show()
			for _,name in pairs(data.bodies) do 
				local body = unit:get_object(Idstring(name))
				local box = vats_panel:child(name)
				if alive(box) then 
					local label = box:child("label")
					if body then 
						local oobb = body:oobb()
						local center = oobb and oobb:center() or unit:position()
						
						local screen_pos = self._ws:world_to_screen(managers.viewport:get_current_camera(),center)
						local pos_x = screen_pos.x
						local pos_y = screen_pos.y
						
						
						--centering
						local screen_unit_pos = self._ws:world_to_screen(managers.viewport:get_current_camera(),unit:position())
						local screen_center_x = screen_unit_pos.x
						local screen_center_y = screen_unit_pos.y
						
						local max_screen_distance = 36
						
						if name == "Head" or name == "Spine" then 
							if name == "Spine" then
								pos_y = pos_y + max_screen_distance
							elseif name == "Head" then 
								pos_y = pos_y - max_screen_distance
							end
							box:child("liner"):set_image("textures/vats_overlay_center")
							box:child("liner"):set_w( math.abs(box:child("liner"):w()))
							box:child("liner"):set_x( 0 )
							box:child("bg"):set_w( math.abs(box:child("bg"):w()))
							box:child("bg"):set_x( 0 )
							box:child("bar"):set_x( data.BAR_X )
							
							label:set_align("center")
							box:child("body_name"):set_align("center")
							
							pos_x = pos_x - (box:w() / 2)
						elseif pos_x > screen_center_x then
							box:child("liner"):set_image("textures/vats_overlay")
							box:child("liner"):set_w( math.abs(box:child("liner"):w()))
							box:child("liner"):set_x( 0 )
							box:child("bg"):set_w( math.abs(box:child("bg"):w()))
							box:child("bg"):set_x( 0 )
							box:child("bar"):set_x( data.BAR_X )
							label:set_align("right")
							box:child("body_name"):set_align("right")
							
							pos_x = screen_center_x + max_screen_distance
						else
							box:child("liner"):set_image("textures/vats_overlay")
							box:child("liner"):set_w( -math.abs(box:child("liner"):w()))
							box:child("liner"):set_x( - box:child("liner"):w())
							box:child("bg"):set_w( -math.abs(box:child("bg"):w()))
							box:child("bg"):set_x( -box:child("bg"):w())
							box:child("bar"):set_x( box:w() - (box:child("bar"):w() + data.BAR_X) )
							label:set_align("left")
							box:child("body_name"):set_align("left")
							
							pos_x = screen_center_x - (max_screen_distance + box:w())
						end
						
						--[[
						
						local screen_center_x,screen_center_y = vats_panel:center()
						local x_dist = screen_center_x - screen_pos.x
						
						local screen_unit_x = pos_x - screen_unit_pos.x
						pos_x = pos_x + (math.clamp((distance_to - 150) * 10,0,50) * -math.sign(screen_unit_x))
						local box_direction = "left"
						
						if math.abs(x_dist) < distance_to / 10 then
							box_direction = "center"
						else
							box_direction = x_dist > 0 and "left" or "right"
						end
						if box_direction == "center" then 
							box:child("liner"):set_image("textures/vats_overlay_center")
							label:set_align("left")
							box:child("body_name"):set_align("left")
							
							box:child("liner"):set_w(math.abs(box:child("liner"):w()))
							box:child("bg"):set_w(math.abs(box:child("bg"):w()))
							box:child("bar"):set_w(math.abs(box:child("bar"):w()))
						else
							box:child("liner"):set_w( math.sign(x_dist) * math.abs(box:child("liner"):w()))
							box:child("bg"):set_w( math.sign(x_dist) * math.abs(box:child("bg"):w()))
							box:child("bar"):set_w( math.sign(x_dist) * math.abs(box:child("bar"):w()))

							label:set_align(box_direction)
							box:child("body_name"):set_align(box_direction)
							box:child("liner"):set_image("textures/vats_overlay")
							pos_x = pos_x + (math.sign(x_dist) * math.clamp((distance_to - 500)/10,0,100))
						end
						--]]
						box:set_position(pos_x,pos_y)
						
						
						if fwd_body == body then 
							label:set_text(self.info.hit)
						else
							if oobb then 
								box:show()
								local vec_to = fire_position - center
								mvector3.normalize(vec_to)
								local dot = mvector3.dot(fire_direction,vec_to)--autoaim.ray or autoaim.normal)
								label:set_text(string.format("%d",math.pow(math.abs(dot),distance_to / 10) * 100) .. "%")
							end
						end
					else
						box:hide()
					end
				end
			end
		else
			vats_panel:hide()
		end
		
		
		
		--local elf = managers.player:local_player():movement():current_state(); _G.herp = elf._equipped_unit:base():check_autoaim(elf:get_fire_weapon_position(), elf:get_fire_weapon_direction(), nil, true)
	end
end


-- MINECRAFT health, armor, xp, level, and hunger

function MHP:_create_hud_minecraft(hud)
	local data = self._huds.minecraft
	local get_rect = data.get_rect

	local minecraft_hud = hud:panel({
		name = "minecraft_hud",
		layer = 1,
		y = -164
	})
	self._huds.minecraft.panel = minecraft_hud
	
	local hotbar = minecraft_hud:bitmap({
		name = "hotbar",
		texture = "textures/minecraft_hotbar",
		visible = true,
		layer = 2
	})
	hotbar:set_size(hotbar:w() / 2,hotbar:h() / 2)
	
	hotbar:set_x((minecraft_hud:w() - hotbar:w()) / 2)
	hotbar:set_y(-64 + minecraft_hud:h() - hotbar:h())
	
	--todo for i=1,self._huds.minecraft.HOTBAR_SLOTS do create_hotbar_box with icon, name, and amount label
	

	local DEFAULT_SIZE = data.DEFAULT_SIZE * data.SCALE
	
	local HEALTH_TICKS = data.HEALTH_TICKS
	local HUNGER_TICKS = data.HUNGER_TICKS
	local ARMOR_TICKS = data.ARMOR_TICKS
	
	local center_x = minecraft_hud:w() / 2
	
	local health_y = hotbar:y() - (DEFAULT_SIZE * 2)
	for i = 1,ARMOR_TICKS do 
		minecraft_hud:bitmap({
			name = "armor_" .. i,
			texture = "textures/minecraft_atlas",
			texture_rect = get_rect("armor_full"),
			w = DEFAULT_SIZE,
			h = DEFAULT_SIZE,
			x = center_x - ((i + 1) * DEFAULT_SIZE),
			y = health_y - (DEFAULT_SIZE),
			layer = 3
		})
	end
	for i = 1,HEALTH_TICKS do
		minecraft_hud:bitmap({
			name = "health_fill_" .. i,
			texture = "textures/minecraft_atlas",
			texture_rect = get_rect("health_heart_full"),
			w = DEFAULT_SIZE,
			h = DEFAULT_SIZE,
			x = center_x - ((i + 1) * DEFAULT_SIZE),
			y = health_y,
			layer = 3
		})
		minecraft_hud:bitmap({
			name = "health_bg_" .. i,
			texture = "textures/minecraft_atlas",
			texture_rect = get_rect("health_empty_black"),
			w = DEFAULT_SIZE,
			h = DEFAULT_SIZE,
			x = center_x - ((i + 1) * DEFAULT_SIZE),
			y = health_y,
			layer = 2
		})
	end
	
	for i = 1,HUNGER_TICKS do 
		minecraft_hud:bitmap({
			name = "hunger_fill_" .. i,
			texture = "textures/minecraft_atlas",
			texture_rect = get_rect("hunger_heart_full"),
			w = DEFAULT_SIZE,
			h = DEFAULT_SIZE,
			x = center_x + ((i - 0) * DEFAULT_SIZE),
			y = health_y,
			layer = 3
		})
		minecraft_hud:bitmap({
			name = "hunger_bg_" .. i,
			texture = "textures/minecraft_atlas",
			texture_rect = get_rect("hunger_empty_black"),
			w = DEFAULT_SIZE,
			h = DEFAULT_SIZE,
			x = center_x + ((i - 0) * DEFAULT_SIZE),
			y = health_y,
			layer = 2
		})
	end
	
	local xp_empty = minecraft_hud:bitmap({ --728 20
		name = "xp_empty",
		texture = "textures/minecraft_xp_empty",
		layer = 2
	})
	xp_empty:set_size(xp_empty:w() / 2,xp_empty:h() / 2)
	
	xp_empty:set_x((minecraft_hud:w() - xp_empty:w()) / 2)
	xp_empty:set_y(hotbar:y() - (xp_empty:h() + 8))
	
	local xp_full = minecraft_hud:bitmap({
		name = "xp_full",
		texture = "textures/minecraft_xp_full",
		layer = 3
	})
	xp_full:set_size(xp_full:w() / 2,xp_full:h() / 2)
	
	xp_full:set_x((minecraft_hud:w() - xp_full:w()) / 2)
	xp_full:set_y(hotbar:y() - (xp_full:h() + 8))
	
	
	
	
	local level = minecraft_hud:text({
		name = "level",
		text = tostring(managers.experience and managers.experience:current_level() or "7"),
		color = Color("B7FD98"),
		font = self._fonts.minecraft,
		font_size = 24,
		layer = 3,
		align = "center",
		y = health_y -- hotbar:y() - 36
	})
	
end

function MHP:SetMinecraftHealth(current,total)
	local ratio = current
	if not current then 
		return
	elseif total then 
		ratio = (current / total)
	end
	ratio = 1 - ratio
	
	local data = self._huds.minecraft
	local panel = data.panel
	
	for i = data.HEALTH_TICKS,1,-1 do 
		local tick = panel:child("health_fill_" .. i)
		local r = (i - 1) / data.HEALTH_TICKS 
		if math.floor(r * 10) >= math.floor(ratio * 10) then
			if r * 10 < ratio * 10 then 
				tick:set_image(data.atlas_name,unpack(data.get_rect("health_heart_half")))
			else
				tick:set_image(data.atlas_name,unpack(data.get_rect("health_heart_full")))
			end
			tick:show()
		else
			tick:hide()
		end
	end
end

function MHP:SetMinecraftArmor(current,total)
	if not (total and current and total > 0) then 
		return
	end
	local ratio = 1 - (current / total)
	
	local data = self._huds.minecraft
	local panel = data.panel
	
	for i = data.ARMOR_TICKS,1,-1 do 
		local tick = panel:child("armor_" .. i)
		local r = (i - 1) / data.ARMOR_TICKS 
		if math.floor(r * 10) >= math.floor(ratio * 10) then
			if r * 10 < ratio * 10 then --and i > 1 then 
				tick:set_image(data.atlas_name,unpack(data.get_rect("armor_half")))
			else
				tick:set_image(data.atlas_name,unpack(data.get_rect("armor_full")))
			end
		else
			tick:set_image(data.atlas_name,unpack(data.get_rect("armor_empty")))
		end
	end
end

function MHP:SetMinecraftHunger(current,total)
	local ratio = current
	if not current then 
		return
	elseif total then 
		ratio = (current / total)
	end
	ratio = 1 - ratio
	
	local data = self._huds.minecraft
	local panel = data.panel
	
	for i = 1,data.HUNGER_TICKS do 
		local tick = panel:child("hunger_fill_" .. i)
		local r = (i - 1) / data.HUNGER_TICKS 
		if math.round(r * 10) >= ratio * 10 then
			tick:show()
			tick:set_image(data.atlas_name,unpack(data.get_rect("hunger_heart_full")))			
		elseif math.round(r * 10) >= math.floor(ratio * 10) then --r <= ratio then 
			tick:show()
			tick:set_image(data.atlas_name,unpack(data.get_rect("hunger_heart_half")))
		else
			tick:hide()
		end
	end
	
end

function MHP:SetMinecraftXP(current,total)
	local data = self._huds.minecraft
	local panel = data.panel
	
	local xp_bg = panel:child("xp_empty")
	local ratio = math.min(current / total,1)
	
	panel:child("xp_full"):set_texture_rect(0,0,ratio * xp_bg:w(),xp_bg:h())
	
	
end


-- TF2 (Team Fortress 2, aka Teams Defense Fort 2, VIDEO GAME) health and ammo

function MHP:_create_hud_tf2(hud)
	local data = self._huds.tf2
	local tf2_hud = hud:panel({
		name = "tf2",
		layer = 3
	})
	self._huds.tf2.panel = tf2_hud
	local health_scale = data.HEALTH_SCALE
	local health_w = 128 * 1
	local health_h = 128 * 1
	local health = tf2_hud:panel({
		name = "health",
		w = health_w * health_scale,
		h = health_h * health_scale,
		x = -64 + (health_w + 256), -- tf2_hud:w() - 
		y = -100 + tf2_hud:h() - (health_h)
	})
	
	--[[
	local health_box = health:bitmap({
		name = "health_box",
		layer = 1,
		texture = "textures/tf2_box"
	})
	health_box:set_y(health:h() - health_box:h())
	health_box:set_w(-health_box:w())
--]]	
	local HEALTH_BITMAP_W = data.HEALTH_BITMAP_W
	local HEALTH_BITMAP_H = data.HEALTH_BITMAP_H
	local health_fill = health:bitmap({
		name = "health_fill",
		layer = 3,
		w = HEALTH_BITMAP_W * health_scale,
		h = HEALTH_BITMAP_H * health_scale,
		texture = "textures/tf2_health_fill"
	})
	local health_ghost = health:bitmap({
		name = "health_ghost",
		layer = 1,
		w = HEALTH_BITMAP_W * health_scale * 1,
		h = HEALTH_BITMAP_H * health_scale * 1,
		color = Color.red,
		texture = "textures/tf2_health_fill",
		alpha = 0
	})
	local health_outline = health:bitmap({
		name = "health_outline",
		layer = 2,
		w = HEALTH_BITMAP_W * health_scale,
		h = HEALTH_BITMAP_H * health_scale,
		texture = "textures/tf2_health_outline"
	})
--	local fill_w,fill_h = health_fill:size()
--	local outline_w,outline_h = health_outline:size()
--	health_fill:set_size(fill_w * health_scale,fill_h * health_scale)
--	health_outline:set_size(outline_w * health_scale,outline_h * health_scale)
	
	
	
--	health_fill:set_center(health:w() / 2,health:h() / 2)
--	health_outline:set_center(health:w() / 2,health:h() / 2)
	
	local health_font_size = 28 * health_scale
	local health_label = health:text({
		name = "health_label",
		layer = 4,
		text = "150",
		align = "center",
		vertical = "center",
		y = -health_font_size,
		font = self._fonts.tf2,
		font_size = health_font_size,
		color = self.color_data.tf2_grey_light,
		alpha = 0.75,
		visible = true
	})
	
	
	local ammo_scale = 1
	local ammo_w = 178 * ammo_scale * data.AMMO_GHOST_SIZE_MUL
	local ammo_h = 84 * ammo_scale * data.AMMO_GHOST_SIZE_MUL --84
	local ammo_mag_font_size = 96 * ammo_scale
	local ammo_reserve_font_size = 40 * ammo_scale
	local ammo_text_x = data.AMMO_TEXT_X
	local ammo_text_ver_offset = -4
	local ammo = tf2_hud:panel({
		name = "ammo",
		w = ammo_w,
		h = ammo_h,
		x =  tf2_hud:w() - (ammo_w + 256),
		y = -100 + tf2_hud:h() - (ammo_h + 32)
	})
	
	local ammo_box = ammo:bitmap({
		name = "ammo_box",
		layer = 1,
		texture = "textures/tf2_box",
--		blend_mode = "mul",
		alpha = 0.9
	})
	local ammo_box_ghost = ammo:bitmap({
		name = "ammo_box_ghost",
		layer = 2,
		texture = "textures/tf2_box",
--		blend_mode = "add",
		alpha = data.AMMO_GHOST_ALPHA,
		visible = false
--		color = Color.red
	})
	ammo_box:set_x(ammo:w() * (data.AMMO_GHOST_SIZE_MUL - 1))
	ammo_box:set_y(ammo:h() - ammo_box:height())
	ammo_box_ghost:set_size(ammo_box:w() * data.AMMO_GHOST_SIZE_MUL,ammo_box:h() * data.AMMO_GHOST_SIZE_MUL)
--	ammo_box_ghost:set_y(ammo:h() - ammo_box:height())
	ammo_box_ghost:set_center(ammo_box:x() + (ammo_box:w() / 2),ammo_box:y() + (ammo_box:h() / 2))

--	local box_center_x = ammo:w() / 2
--	local box_center_y = ammo:h() / 2
--	ammo_box:set_center(box_center_x,box_center_y)
--	ammo_box_ghost:set_center(box_center_x,box_center_y)
	
	local ammo_mag_label = ammo:text({
		name = "ammo_mag_label",
		text = "4",
		align = "right",
		x = ammo_text_x - ammo:w(),
		y = ammo_text_ver_offset + ammo:h() - ammo_mag_font_size,
		font = self._fonts.tf2_build,
		font_size = ammo_mag_font_size,
		color = self.color_data.tf2_cream,
		layer = 4,
		visible = true
	})
	local ammo_mag_shadow = ammo:text({
		name = "ammo_mag_shadow",
		text = "4",
		align = "right",
		x = 1 + ammo_text_x - ammo:w(),
		y = 1 + ammo_text_ver_offset + ammo:h() - ammo_mag_font_size,
		font = self._fonts.tf2_build,
		font_size = ammo_mag_font_size,
		color = Color.black,
		layer = 3,
		visible = true
	})
	local ammo_reserve_label = ammo:text({
		name = "ammo_reserve_label",
		text = "16",
		align = "left",
--		vertical = "bottom",
		x = ammo_text_x + 4,
--		y = ammo_mag_font_size,
		y = ammo_text_ver_offset + ammo:h() - (1.2 * ammo_reserve_font_size),
		font = self._fonts.tf2,
		font_size = ammo_reserve_font_size,
		color = self.color_data.tf2_cream,
		layer = 4,
		visible = true
	})
	local ammo_reserve_shadow = ammo:text({
		name = "ammo_reserve_shadow",
		text = "16",
		align = "left",
		x = 1 + ammo_text_x + 4,
		y = 1 + ammo_text_ver_offset + ammo:h() - (1.2 * ammo_reserve_font_size),
		font = self._fonts.tf2,
		font_size = ammo_reserve_font_size,
		color = Color.black,
		layer = 3,
		visible = true
	})
	
--MHP._huds.tf2.panel:child("ammo"):child("ammo_box_ghost")
--MHP._huds.tf2.panel:child("health"):rect({alpha = 0.1})

	
end

function MHP:SetTF2Health(current,total)
	local data = self._huds.tf2
	local health_panel = data.panel:child("health")
	local health_label = health_panel:child("health_label")
	local health_bitmap = health_panel:child("health_fill")
	local health_outline = health_panel:child("health_outline")
	local health_ghost = health_panel:child("health_ghost")
	
	health_label:set_text(string.format("%d",current * 10))
	
	if total then 
		local ratio = current / total
		local w = data.HEALTH_BITMAP_W * data.HEALTH_SCALE
		local h = data.HEALTH_BITMAP_H * data.HEALTH_SCALE
		health_bitmap:set_texture_rect(0,data.HEALTH_BITMAP_W * (1 - ratio),data.HEALTH_BITMAP_W,data.HEALTH_BITMAP_H * ratio)
		health_bitmap:set_size(w,h * ratio)
		health_bitmap:set_position((health_bitmap:parent():w() - health_bitmap:w()) / 2,health_bitmap:parent():h() - health_bitmap:h())
		if ratio <= data.HEALTH_LOW_THRESHOLD then 
			health_bitmap:set_color(Color.red)
			health_ghost:show()
			local r = 3 - (ratio / data.HEALTH_LOW_THRESHOLD)
			health_ghost:set_size(w * r,h * r)
			health_ghost:set_center(health_outline:x() + (health_outline:w() / 2),health_outline:y() + (health_outline:h() / 2))
		else
			health_ghost:hide()
			health_bitmap:set_color(Color.white)
		end
		
	end
	--MHP._huds.tf2.panel:child("health"):child("health_fill"):set_texture_rect({0,0,128,128})
end

function MHP:AnimateTF2LowHealth(t,dt)
	local data = self._huds.tf2
	local health_panel = data.panel:child("health")
	local health_ghost = health_panel:child("health_ghost")
	local a = (0.5 + math.sin(t * 1666)) / 2
	health_ghost:set_alpha(a)
end

function MHP:SetTF2Ammo(mag,reserves,max_mag)
	local data = self._huds.tf2
	local ammo_panel = data.panel:child("ammo")
	ammo_panel:child("ammo_mag_label"):set_text(math.min(mag,99))
	ammo_panel:child("ammo_mag_shadow"):set_text(math.min(mag,99))
	ammo_panel:child("ammo_reserve_label"):set_text(math.min(reserves,99))
	ammo_panel:child("ammo_reserve_shadow"):set_text(math.min(reserves,99))
	
	ammo_panel:child("ammo_box_ghost"):set_visible(mag / max_mag <= data.AMMO_LOW_THRESHOLD)
end

function MHP:AnimateTF2LowAmmo(t,dt)
	local data = self._huds.tf2
	local ammo_panel = data.panel:child("ammo")
	local ammo_box_ghost = ammo_panel:child("ammo_box_ghost")
	local a = (1 + math.sin(t * 1500)) / 2
	if a > 0.2 then 
		ammo_box_ghost:set_alpha(data.AMMO_GHOST_ALPHA)
	else 
		ammo_box_ghost:set_alpha(0)
	end
	
end


-- HL2 (Half-Life 2) health and suit/armor

function MHP:_create_hud_hl2(hud) --this one goes out to vxwolf... sorry again
	local hl2 = hud:panel({
		name = "hl2"
	})
	self._huds.hl2.panel = hl2
	
	local crosshairs = hl2:panel({
		name = "crosshairs"
	})
	
	local crosshair_font_size = 32
	local crosshair_dots = crosshairs:text({
		name = "crosshair_dots",
		text = "Q",
		vertical = "center",
		align = "center",
		y = -crosshair_font_size * 0.9,
		font = self._fonts.hl2_icons,
		font_size = crosshair_font_size
	})
	local crosshair_left = crosshairs:text({
		name = "crosshair_left",
		text = "[",
		vertical = "center",
		align = "center",
		x = -16,
		y = -crosshair_font_size,
		font = self._fonts.hl2_icons,
		font_size = crosshair_font_size
	})
	local crosshair_right = crosshairs:text({
		name = "crosshair_right",
		text = "]",
		vertical = "center",
		align = "center",
		x = 16,
		y = -crosshair_font_size,
		font = self._fonts.hl2_icons,
		font_size = crosshair_font_size
	})
	
	local box_scale = 1
	local box_w = 128 * box_scale
	local box_h = 48 * box_scale
	
	local text_name_size = 16 * box_scale
	local text_label_size = 32 * box_scale
	
	local box_ver_offset = -32
	local text_ver_offset = -8
	local health = hl2:panel({
		name = "health",
		w = box_w,
		h = box_h,
		x = 48 + 24,
		y = -128 + box_ver_offset + hl2:h() - box_h
	})
	
	local health_bg = health:bitmap({
		name = "health_bg",
		layer = 1,
		texture = "guis/textures/pd2/hud_tabs",
		texture_rect = {84,0,44,32},
		w = health:w(),
		h = health:h(),
		alpha = 0.75
	})
	local health_name = health:text({
		name = "health_name",
		text = "HEALTH",
		x = 8,
		y = text_ver_offset + health:h() - text_name_size,
		font = self._fonts.hl2_text,
		font_size = text_name_size,
		color = self.color_data.hl2_yellow,
		alpha = 2/3,
		layer = 2
	})
	local health_label = health:text({
		name = "health_label",
		text = "96",
		align = "right",
		x = -text_label_size,
		y = text_ver_offset + health:h() - text_label_size,
		font = self._fonts.hl2_icons,
		font_size = text_label_size,
		color = self.color_data.hl2_yellow,
		alpha = 2/3,
		layer = 2
	})
	
	local suit = hl2:panel({
		name = "suit",
		w = box_w,
		h = box_h,
		x = 24 + health:right(),
		y = -128 + box_ver_offset + hl2:h() - box_h
	})
	
	local suit_bg = suit:bitmap({
		name = "suit_bg",
		layer = 1,
		texture = "guis/textures/pd2/hud_tabs",
		texture_rect = {84,0,44,32},
		w = suit:w(),
		h = suit:h(),
		alpha = 0.75
	})
	local suit_name = suit:text({
		name = "suit_name",
		text = "SUIT",
		x = 8,
		y = text_ver_offset + suit:h() - text_name_size,
		font = self._fonts.hl2_text,
		font_size = text_name_size,
		color = self.color_data.hl2_yellow,
		alpha = 2/3,
		layer = 2
	})
	local suit_label = suit:text({
		name = "suit_label",
		text = "100",
		align = "right",
		x = -text_label_size,
		y = text_ver_offset + suit:h() - text_label_size,
		font = self._fonts.hl2_icons,
		font_size = text_label_size,
		color = self.color_data.hl2_yellow,
		alpha = 2/3,
		layer = 2
	})

	--[[ hl2:

	health: *
	energy: +
	crosshair (): O
	crosshair dots: Q 
	crosshair ( fill: [
	crouch: \
	crosshair ) fill: ]
	crosshair ( empty: {
	crosshair ) empty:}
	flashlight on: copyright
	flashlight off: (r)
	--]]

end

function MHP:SetHL2Suit(value)
	self._huds.hl2.panel:child("suit"):child("suit_label"):set_text(string.format("%d",value * 10))
end

function MHP:SetHL2Health(value)
	self._huds.hl2.panel:child("health"):child("health_label"):set_text(string.format("%d",value * 10))
end


-- LEGO video game franchise character icons

function MHP:_create_hud_lego(hud)
	local data = self._huds.lego
	local lego = hud:panel({
		name = "lego"
	})
	self._huds.lego.panel = lego
	
	local size = data.SIZE
	local character_icon = lego:bitmap({
		name = "character_icon",
		layer = 1,
		texture = data.atlas_name,
		texture_rect = {size * (math.random(8) - 1),size * (math.random(2) - 1),size,size},
		w = size,
		h = size,
		x = 96,
		y = 96
	})
end


-- Pokemon GO (cosmetic/nonfunctional)

function MHP:_create_hud_pogo(hud)
	local data = self._huds.pogo
	local pogo = hud:panel({
		name = "pogo"
	})
	self._huds.pogo.panel = pogo
	
	local size = data.SIZE * data.SCALE
	
	local run_icon = pogo:bitmap({
		name = "run_icon",
		layer = 1,
		texture = data.atlas_name,
		texture_rect = data.get_rect("run"),
		w = size,
		h = size,
		x = 24,
		y = 128,
	})
	
	local dex_icon = pogo:bitmap({
		name = "dex_icon",
		layer = 1,
		texture = data.atlas_name,
		texture_rect = data.get_rect("dex"),
		w = size,
		h = size,
		x = 24,
		y = run_icon:bottom(),
	})
	
	local ar_icon = pogo:bitmap({
		name = "ar_icon",
		layer = 3,
		texture = data.atlas_name,
		texture_rect = data.get_rect("ar"),
		w = size,
		h = size,
		x = pogo:w() - size,
		y = 169,
	})
	
	local cam_icon = pogo:bitmap({
		name = "cam_icon",
		layer = 3,
		texture = data.atlas_name,
		texture_rect = data.get_rect("camera"),
		w = size,
		h = size,
		x = pogo:w() - size,
		y = ar_icon:bottom(),
	})
	
	local bag_icon = pogo:bitmap({
		name = "bag_icon",
		layer = 3,
		texture = data.atlas_name,
		texture_rect = data.get_rect("bag"),
		w = size,
		h = size,
		x = pogo:w() - size,
		y = cam_icon:bottom(),
	})
	
	local shop_icon = pogo:bitmap({
		name = "shop_icon",
		layer = 3,
		texture = data.atlas_name,
		texture_rect = data.get_rect("shop"),
		w = size,
		h = size,
		x = pogo:w() - size,
		y = bag_icon:bottom(),
	})
end


-- XCOM: Enemy Unknown

function MHP:_create_hud_xcom(hud)
	local data = self._huds.xcom
	local xcom = hud:panel({
		name = "xcom",
		layer = 3
	})
	self._huds.xcom.panel = xcom
	
	local w = data.BOX_W * data.SCALE
	local h = data.BOX_H * data.SCALE
	local ver_offset = data.VER_OFFSET
	local name_font_size = 24 * data.SCALE
	local desc_font_size = 14 * data.SCALE
	
	local xcom_box = xcom:panel({
		name = "xcom_box",
		layer = 2,
		w = w,
		h = h,
		x = (xcom:w() - w) / 2,
		y = xcom:h() - (h + ver_offset)
	})
	local attack_box = xcom_box:bitmap({
		name = "attack_box",
		layer = 1,
		texture = "textures/xcom_box",
		w = w,
		h = h
	})
	local action_name = xcom_box:text({
		name = "action_name",
		layer = 2,
		text = data.action_name_string,
		align = "center",
		font = self._fonts.eurostile,
		font_size = name_font_size,
		color = self.color_data.xcom_blue,
		y = name_font_size / 2,
		kern = 2
	})
--	action_name:set_kern(2)
	local action_desc = xcom_box:text({
		name = "action_desc",
		layer = 2,
		text = data.action_desc_string,
		align = "center",
		y = name_font_size + desc_font_size,
		font = self._fonts.eurostile,
		font_size = desc_font_size,
		color = self.color_data.xcom_blue,
		visible = true,
		kern = 2
	})
--	action_desc:set_kern(2)
	
	local hit_chance = xcom_box:text({
		name = "hit_chance",
		layer = 2,
		text = data.hit_chance_string,
		align = "left",
		x = 24,
		y = 64,
		font = self._fonts.eurostile,
		font_size = desc_font_size,
		color = self.color_data.xcom_blue,
		visible = true,
		kern = 2
	})
	local crit_chance = xcom_box:text({
		name = "crit_chance",
		layer = 2,
		text = data.crit_chance_string,
		align = "right",
		x = -24,
		y = 64,
		font = self._fonts.eurostile,
		font_size = desc_font_size,
		color = self.color_data.xcom_yellow,
		visible = true,
		kern = 2
	})
	local more_info = xcom_box:text({
		name = "crit_chance",
		layer = 2,
		text = "MORE INFO",
		align = "center",
		y = 96,
		font = self._fonts.eurostile,
		font_size = desc_font_size,
		color = self.color_data.xcom_blue,
		visible = true,
		kern = 2
	})
	
end
	
function MHP:UpdateXCOMBox(t,dt)
	local weapon_name = self.info.weapon_name
	local crit_chance = self.info.crit
	local hit_chance = self.info.hit
	
	local damage = self.info.damage
	
	local data = self._huds.xcom
	
	local xcom_hud = data.panel:child("xcom_box")
	xcom_hud:child("action_name"):set_text(string.gsub(data.action_name_string,"$WEAPON_NAME",weapon_name))
	xcom_hud:child("action_desc"):set_text(string.gsub(data.action_desc_string,"$DAMAGE",string.format("%d",damage * 10)))
	xcom_hud:child("hit_chance"):set_text(string.gsub(data.hit_chance_string,"$CHANCE",string.format("%d",hit_chance * 100)))
	xcom_hud:child("crit_chance"):set_text(string.gsub(data.crit_chance_string,"$CHANCE",string.format("%d",crit_chance * 100)))
	
end	


-- Portal

function MHP:_create_hud_portal(hud)
	local portal_hud = hud:panel({
		name = "portal"
	})
	self._huds.portal.panel = portal_hud
	local data = self._huds.portal
	local w = data.CROSSHAIR_W * data.SCALE
	local h = data.CROSSHAIR_H * data.SCALE
	local crosshairs = portal_hud:panel({
		name = "crosshairs",
		w = w,
		h = h,
		x = (portal_hud:w() - w) / 2,
		y = (portal_hud:h() - h) / 2
	})
	
	local crosshair_blue = crosshairs:bitmap({
		name = "crosshair_blue",
		layer = 1,
		rotation = 0,
		texture = "textures/portal_crosshair",
--		texture_rect = crosshair_rect,
		w = w,
		h = h,
		color = self.color_data.portal_blue,
		alpha = 0.75,
		visible = true
	})
	local crosshair_orange = crosshairs:bitmap({
		name = "crosshair_orange",
		layer = 1,
		rotation = 180,
		texture = "textures/portal_crosshair",
		w = w,
		h = h,
		color = self.color_data.portal_orange,
		alpha = 0.75,
		visible = true,
	})
end


-- GTA (Grand Theft Auto)

function MHP:_create_hud_gta(hud)

	local gta_hud = hud:panel({
		name = "gta"
	})
	self._huds.gta.panel = gta_hud
	local data = self._huds.gta
	
	local font_size = data.font_size
	
	local gta_clock = gta_hud:text({
		name = "gta_clock",
		layer = 5,
		text = "04:20",
		align = "right",
		x = -32,
		y = font_size,
		font = self._fonts.gta_outline,
		font_size = font_size,
		color = Color.white,
		visible = true,
		kern = 4
	})
	
	local gta_money = gta_hud:text({
		name = "gta_money",
		layer = 2,
		text = "$0000300",
		align = "right",
		x = -32,
		y = 64,
		font = self._fonts.gta_outline,
		font_size = font_size,
		color = self.color_data.gta_green,
		visible = true,
		kern = 4
	})
end

function MHP:SetGTAMoney(amount)
	local data = self._huds.gta
	amount = math.clamp(amount,0,tonumber(string.rep("9",data.cash_digits)))
	data.panel:child("gta_money"):set_text("$" .. string.format("%0" .. data.cash_digits .. "d",amount))
end

function MHP:SetGTAClock(epoch)
	local data = self._huds.gta
	local time_formatted
	if data.military_time then 	
		time_formatted = os.date("%H:%M",epoch)
	else
		if data.show_ampm then 
			time_formatted = os.date("%I:%M%p",epoch)
		else
			time_formatted = os.date("%I:%M",epoch)
		end
	end
	data.panel:child("gta_clock"):set_text(time_formatted)
end


-- Stardew Valley

function MHP:_create_hud_stardew(hud)

	local stardew = hud:panel({
		name = "stardew"
	})
	self._huds.stardew.panel = stardew
	local data = self._huds.stardew
	
	local scale = data.scale
	local money_font_size = data.money_font_size * scale
	local clock_font_size = data.clock_font_size * scale
	
	local bar_font_size = data.bar_font_size * scale
	
	local STARDEW_HUD_X = data.STARDEW_HUD_X * scale
	local STARDEW_HUD_Y = data.STARDEW_HUD_Y * scale
	
	local STARDEW_HUD_W = data.STARDEW_HUD_W * scale
	local STARDEW_HUD_H = data.STARDEW_HUD_H * scale
	local STARDEW_VITALS_W = data.STARDEW_VITALS_W * scale
	local STARDEW_VITALS_H = data.STARDEW_VITALS_H * scale
	
	local STARDEW_VITALS_X = data.STARDEW_VITALS_X
	local STARDEW_VITALS_Y = data.STARDEW_VITALS_Y
	
	local STARDEW_CLOCK_HAND_X = data.STARDEW_CLOCK_HAND_X * scale
	local STARDEW_CLOCK_HAND_Y = data.STARDEW_CLOCK_HAND_Y * scale
	
	local STARDEW_CLOCK_X = data.STARDEW_CLOCK_X * scale
	local STARDEW_CLOCK_Y = data.STARDEW_CLOCK_Y * scale
	
	local STARDEW_DATE_X = data.STARDEW_DATE_X * scale
	local STARDEW_DATE_Y = data.STARDEW_DATE_Y * scale
	
	local STARDEW_MONEY_X = data.STARDEW_MONEY_X * scale
	local STARDEW_MONEY_Y = data.STARDEW_MONEY_Y * scale
	local STARDEW_MONEY_SPACER = data.STARDEW_MONEY_SPACER
	
	local STARDEW_BAR_X = data.STARDEW_BAR_X * scale
	local STARDEW_BAR_Y = data.STARDEW_BAR_Y * scale
	local STARDEW_BAR_W = data.STARDEW_BAR_W * scale
	local STARDEW_BAR_H = data.STARDEW_BAR_H * scale
	
	local weather_w = data.weather_w * scale
	local weather_h = data.weather_h * scale
	
	local STARDEW_WEATHER_X = data.STARDEW_WEATHER_X * scale
	local STARDEW_WEATHER_Y = data.STARDEW_WEATHER_Y * scale
	
	local season_w = data.season_w * scale
	local season_h = data.season_h * scale
	
	local STARDEW_SEASON_X = data.STARDEW_SEASON_X * scale
	local STARDEW_SEASON_Y = data.STARDEW_SEASON_Y * scale
	
	local STARDEW_SEASON_W = data.STARDEW_SEASON_W * scale
	local STARDEW_SEASON_H = data.STARDEW_SEASON_H * scale
	
	local STARDEW_WEATHER_W = data.STARDEW_WEATHER_W * scale
	local STARDEW_WEATHER_H = data.STARDEW_WEATHER_H * scale
	
	local stardew_box = stardew:panel({
		name = "stardew_box",
		layer = 1,
		w = STARDEW_HUD_W,
		h = STARDEW_HUD_H,
		x = STARDEW_HUD_X + (stardew:w() - (STARDEW_HUD_W + 24)),
		y = STARDEW_HUD_Y
	})
	local stardew_hud = stardew_box:bitmap({
		name = "stardew_hud",
		texture = "textures/stardew_hud",
		layer = 2
	})
	local stardew_clock_hand = stardew_box:bitmap({
		name = "stardew_clock_hand",
		texture = "textures/stardew_clock_hand",
		x = STARDEW_CLOCK_HAND_X,
		y = STARDEW_CLOCK_HAND_Y,
		layer = 3
	})
	
	local stardew_weather = stardew_box:bitmap({
		name = "stardew_weather",
--		alpha = 0,
		w = STARDEW_WEATHER_W,
		h = STARDEW_WEATHER_H,
		x = STARDEW_WEATHER_X,
		y = STARDEW_WEATHER_Y,
		layer = 3
	})
	local stardew_season = stardew_box:bitmap({
		name = "stardew_season",
--		alpha = 0,
		w = STARDEW_SEASON_W,
		h = STARDEW_SEASON_H,
		x = STARDEW_SEASON_X,
		y = STARDEW_SEASON_Y,
		layer = 3
	})
	
	local stardew_clock = stardew_box:text({
		name = "stardew_clock",
		layer = 4,
		text = "4:20", --"%I:%M %p"
		align = "center",
		x = STARDEW_CLOCK_X,
		y = STARDEW_CLOCK_Y,
		font = self._fonts.stardew_clock,
		font_size = clock_font_size,
		color = self.color_data.stardew_brown,
		visible = true
	})
	
	local stardew_clock_shadow = stardew_box:text({
		name = "stardew_clock_shadow",
		layer = 3,
		text = "4:20", --"%I:%M %p"
		align = "center",
		x = STARDEW_CLOCK_X - (1 * scale),
		y = STARDEW_CLOCK_Y + (1 * scale),
		font = self._fonts.stardew_clock,
		font_size = clock_font_size,
		color = self.color_data.stardew_shadow,
		visible = true
	})
	
	local stardew_date = stardew_box:text({
		name = "stardew_date",
		layer = 4,
		text = "Wed. 11", --"%a. %d"
		align = "center",
		x = STARDEW_DATE_X,
		y = STARDEW_DATE_Y,
		font = self._fonts.stardew_clock,
		font_size = clock_font_size,
		color = self.color_data.stardew_brown,
		visible = true
	})
	
	local stardew_date_shadow = stardew_box:text({
		name = "stardew_date_shadow",
		layer = 3,
		text = "Wed. 11", --"%a. %d"
		align = "center",
		x = STARDEW_DATE_X - (1 * scale),
		y = STARDEW_DATE_Y + (1 * scale),
		font = self._fonts.stardew_clock,
		font_size = clock_font_size,
		color = self.color_data.stardew_shadow,
		visible = true
	})
	
	local function create_cash(i)

		local money = stardew_box:text({
			name = "money_" .. i,
			layer = 4,
			text = "",
			align = "center",
			x = STARDEW_MONEY_X + (STARDEW_MONEY_SPACER * (i - 6)),
			y = STARDEW_MONEY_Y,
			font = self._fonts.stardew_money,
			font_size = money_font_size,
			color = self.color_data.stardew_red,
			visible = true
		})
	end
	
	for i = 1,data.cash_digits do 
		create_cash(i)
	end
	local stardew_vitals = stardew:panel({
		name = "stardew_vitals",
		layer = 3
	})
	
	local stardew_health = stardew_vitals:bitmap({
		name = "stardew_health",
		texture = "textures/stardew_health",
		w = STARDEW_VITALS_W,
		h = STARDEW_VITALS_H,
		layer = 3,
		x = STARDEW_VITALS_X + (stardew:w() - ( 2.1 * STARDEW_VITALS_W)),
		y = STARDEW_VITALS_Y
	})
	
	
	local stardew_energy = stardew_vitals:bitmap({
		name = "stardew_energy",
		texture = "textures/stardew_energy",
		w = STARDEW_VITALS_W,
		h = STARDEW_VITALS_H,
		layer = 3,
		x = STARDEW_VITALS_X + (stardew:w() - STARDEW_VITALS_W),
		y = STARDEW_VITALS_Y
	})
	
	local health_bar = stardew_vitals:rect({
		name = "health_bar",
		color = self.color_data.stardew_bar_full,
		x = stardew_health:x() + STARDEW_BAR_X,
		y = stardew_health:y() + STARDEW_BAR_Y,
		w = STARDEW_BAR_W,
		h = STARDEW_BAR_H,
		layer = 4
	})
	
	local energy_bar = stardew_vitals:rect({
		name = "energy_bar",
		color = self.color_data.stardew_bar_full,
		x = stardew_energy:x() + STARDEW_BAR_X,
		y = stardew_energy:y() + STARDEW_BAR_Y,
		w = STARDEW_BAR_W,
		h = STARDEW_BAR_H,
		layer = 4
	})
	
	
	--hidden
	local energy_label = stardew_vitals:text({
		name = "energy_label",
		layer = 5,
		text = "",
--		align = "right",
		x = health_bar:x(),
		y = energy_bar:bottom(),
		font = self._fonts.stardew_clock,
		font_size = bar_font_size,
		color = Color.white,
		visible = false
	})
	
	local health_label = stardew_vitals:text({
		name = "health_label",
		layer = 5,
		text = "",
--		align = "right",
		x = health_bar:x(),
		y = health_bar:bottom(),
		font = self._fonts.stardew_clock,
		font_size = bar_font_size,
		color = Color.white,
		visible = false
	})
	self:SetStardewSeason()
	self:RefreshStardewWeather()
end

function MHP:SetStardewMoney(value)
	local data = self._huds.stardew
	local panel = data.panel
	value = math.max(0,math.floor(value))
	value = math.min(value,tonumber(string.rep("9",data.cash_digits)))
--[[
--	value = math.floor(math.clamp(value,0,tonumber(string.rep("9",data.cash_digits)) or 99999999))

When I used the above commented line, values above 99,999,999 would round up to 100,000,000.
I will explain why I used separate calls to math.min() and math.max() with the following console output,
from when I was debugging this issue:

07:18:04 PM Lua: CONSOLE: > return tonumber(string.rep("9",8))
07:18:04 PM Lua: CONSOLE: 99999999
07:18:22 PM Lua: CONSOLE: > return math.clamp(123456789,0,tonumber(string.rep("9",8)))
07:18:22 PM Lua: CONSOLE: 100000000
--]]

	local text = string.format(string.gsub(value,"%D",""))
	
	for n = 1,data.cash_digits do 
		local money = panel:child("stardew_box"):child("money_" .. n)
		if money then 
			local index = string.len(text) - (data.cash_digits - n)
			if index <= 0 then 
				index = 9
			end
			money:set_text(string.sub(text,index,index) or "-")
		end
	end
end

function MHP:SetStardewClock(epoch,t,dt)
	local data = self._huds.stardew
	local panel = data.panel
	local div = ":"
	if math.floor(t) % 2 == 0 then 
		div = " "
	end
	

	local hour = tonumber(os.date("%H"))
	local text 
	if hour > 9 then 
		text = os.date("%I" .. div .. "%M",epoch) .. " " .. utf8.to_lower(os.date("%p"))
	else
		text = string.sub(os.date("%I" .. div .. "%M",epoch),2) .. " " .. utf8.to_lower(os.date("%p"))
	end
	
	panel:child("stardew_box"):child("stardew_clock"):set_text(text)
	panel:child("stardew_box"):child("stardew_clock_shadow"):set_text(text)
	
	
	if hour > 18 or hour < 2 then 
		hour = 18
	elseif hour < 6 then 
		hour = 6
	end
	local angle = 180 * ((hour - 6) / (18 - 6))
	panel:child("stardew_box"):child("stardew_clock_hand"):set_rotation(angle)
--	MHP._huds.stardew.panel:child("stardew_box"):child("stardew_clock_hand"):set_rotation(15)
end

function MHP:SetStardewDate(epoch)
	local data = self._huds.stardew
	local panel = data.panel
	local text = os.date("%a. %d",epoch)
	panel:child("stardew_box"):child("stardew_date"):set_text(text)
	panel:child("stardew_box"):child("stardew_date_shadow"):set_text(text)
end

function MHP:AnimateStardewHealth(t,dt)
	--shake anim
	
	local data = self._huds.stardew
	local panel = data.panel
	local stardew_health = panel:child("stardew_vitals"):child("stardew_health")
	
	local ratio = self.info.health_current / self.info.health_total
	local offset_x = 0
	local offset_y = 0
	if ratio <= data.bar_empty_threshold then 
		local shake_intensity = math.min(4,1/ratio)
		offset_x = math.sin(t * data.bar_shake_speed) * data.bar_shake_intensity_hor * shake_intensity
		offset_y = math.cos(t * data.bar_shake_speed) * data.bar_shake_intensity_ver * shake_intensity
	end
	local scale = data.scale
	local vitals_w = data.STARDEW_VITALS_W * scale
	local vitals_x = (data.STARDEW_VITALS_X * scale) + (panel:w() - ( 2.1 * vitals_w))
	local vitals_y = data.STARDEW_VITALS_Y * scale
	stardew_health:set_position(offset_x + vitals_x,offset_y + vitals_y)
	
	local bar_h = data.STARDEW_BAR_H * scale
	local bar_y = (data.STARDEW_BAR_Y * scale) + stardew_health:y()
	panel:child("stardew_vitals"):child("health_bar"):set_position(offset_x + vitals_x + (data.STARDEW_BAR_X * scale),bar_y + (bar_h * (1 - ratio)))
end

function MHP:SetStardewHealth(current,total)
	if total then 
		local ratio = current/total
		
		local data = self._huds.stardew
		local panel = data.panel
		
		local bar_h = data.STARDEW_BAR_H * data.scale
		local bar_y = (data.STARDEW_BAR_Y * data.scale) + panel:child("stardew_vitals"):child("stardew_health"):y()
		local health_bar = panel:child("stardew_vitals"):child("health_bar")
		health_bar:set_h(bar_h * ratio)
		health_bar:set_y(bar_y + (bar_h * (1 - ratio)))
		
		if ratio <= data.bar_empty_threshold then 
			health_bar:set_color(self.color_data.stardew_bar_empty)
		elseif ratio <= data.bar_low_threshold then 
			health_bar:set_color(self.color_data.stardew_bar_low)
		else
			health_bar:set_color(self.color_data.stardew_bar_full)
		end
		--MHP:SetStardewHealth(1,2)
		panel:child("stardew_vitals"):child("health_label"):set_text(string.format("%d",current * 10) .. " / " .. string.format("%d",total*10))
	end
end

function MHP:SetStardewEnergy(current,total)
	if total then 
		local ratio = current/total
		
		local data = self._huds.stardew
		local panel = data.panel
		
		local bar_h = data.STARDEW_BAR_H * data.scale
		local bar_y = (data.STARDEW_BAR_Y * data.scale) + panel:child("stardew_vitals"):child("stardew_energy"):y()
		local health_bar = panel:child("stardew_vitals"):child("energy_bar")
		health_bar:set_h(bar_h * ratio)
		health_bar:set_y(bar_y + (bar_h * (1 - ratio)))
		
		if ratio <= data.bar_empty_threshold then 
			health_bar:set_color(self.color_data.stardew_bar_empty)
		elseif ratio <= data.bar_low_threshold then 
			health_bar:set_color(self.color_data.stardew_bar_low)
		else
			health_bar:set_color(self.color_data.stardew_bar_full)
		end
		--MHP:SetStardewHealth(1,2)
		panel:child("stardew_vitals"):child("energy_label"):set_text(string.format("%d",current * 10) .. " / " .. string.format("%d",total*10))
	end
end

function MHP:AnimateStardewMoney(t,dt)
	local delta = self.info.money_interp_start - self.info.money
	local data = self._huds.stardew
	local panel = data.panel
	local shake_intensity = 0
	if delta ~= 0 then 
		shake_intensity = math.sign(delta) * math.min(math.abs(delta),data.max_shake_money) / 100000
	end
	
	for n = 1,data.cash_digits do 
		local money = panel:child("stardew_box"):child("money_" .. n)
		local shake = shake_intensity * math.sin((n + t) * delta * 500)
		local y = data.STARDEW_MONEY_Y * data.scale
		money:set_y(y + shake)
	end
end

function MHP:RefreshStardewWeather()
	dohttpreq("http://ip-api.com/json", function(raw_data)
		local location_data = json.decode(raw_data or {})
--		self:log("Did location data query: " .. tostring(raw_data))
		self:QueryWeather(location_data)
	end)
end

function MHP:RefreshStardewWeatherOld() --obsolete
	local data = self._huds.stardew

	local location_data
	
	dohttpreq("http://ip-api.com/json", function(raw_data)
		location_data = json.decode(raw_data or {})
		self:QueryWeather(location_data)
	end)
	
	
	
	
	local season_icon = data.get_season_icon("Spring")
	local weather_icon = data.get_weather_icon("sun")
	if location_data then 		
		local weather_data

		local city_id = location_data.city
		local lat = tonumber(location_data.lat)
		local lon = tonumber(location_data.lon)
		if city_id then
			local weather_req = "http://api.openweathermap.org/data/2.5/weather?id=$CITY&appid=$APIKEY"
			weather_req = string.gsub(weather_req,"$CITY",city_id)
			weather_req = string.gsub(weather_req,"$APIKEY",api_key)
			
			dohttpreq(weather_req, function(raw_data)
				weather_data = json.decode(raw_data or {})
				--self:log("Found weather data for " .. tostring(city_id))
			end)
		elseif lat and lon then
			local weather_req = "http://api.openweathermap.org/data/2.5/weather?lat=$LON&lon=$LON&appid=http://api.openweathermap.org/data/2.5/weather?lat=37.4043&lon=-122.0748&appid=$APIKEY"
			weather_req = string.gsub(weather_req,"$LON",lon)
			weather_req = string.gsub(weather_req,"$LAT",lat)
			weather_req = string.gsub(weather_req,"$APIKEY",api_key)
			dohttpreq(weather_req, function(raw_data)
				weather_data = json.decode(raw_data or {})
				--self:log("Found weather data by lat/lon")
			end)
		end
		
		local weather_name = "Clear"
		if weather_data then 
			if weather_data.weather then 
				weather_name = weather_data.weather.main or weather_name
			end
		end
		
		local weather_type = data.weather_ids[weather_name] or "sun"
		
		
		local season = "Spring"
		local month_num = tonumber(os.date("%m"))
		if month_num == 12 or month_num <= 2 then 
			season = "Winter"
		elseif month_num <= 5 then 
			season = "Spring"
		elseif month_num <= 8 then
			season = "Summer"
		elseif month_num <= 11 then
			season = "Fall"
		end
		
		if season == "Spring" or season == "Summer" then 
			if weather_type == "wind" then 
				weather_icon = data.get_weather_icon("wind_spring")
			end
		elseif season == "Winter" or season == "Fall" then
			if weather_type == "wind" then 
				weather_icon = data.get_weather_icon("wind_fall")
			end
		end
		weather_icon = weather_icon or data.get_weather_icon(weather_type)
		
		season_icon = data.get_season_icon(season)
	else
		--self:log("Location data not found!")
	end
	
--	self:log("Weather is " .. table.concat(weather_icon or {}))
--	self:log("Season is " .. table.concat(season_icon or {}))
	local stardew_box = data.panel:child("stardew_box")
	stardew_box:child("stardew_weather"):set_image(data.weather_atlas_name,unpack(weather_icon))
	stardew_box:child("stardew_season"):set_image(data.season_atlas_name,unpack(season_icon))
	
end

function MHP:QueryWeather(location_data) --called once per heist, on heist start
	if location_data then 
		local city_check_enabled = false

		local api_key = "e7862b311bbe9f1bee723872dd5d2e81"
		local city_id = location_data.city
		local lat = tonumber(location_data.lat)
		local lon = tonumber(location_data.lon)
		if city_id and city_check_enabled then
			local weather_req = "http://api.openweathermap.org/data/2.5/weather?id=$CITY&appid=$APIKEY"
			weather_req = string.gsub(weather_req,"$CITY",city_id)
			weather_req = string.gsub(weather_req,"$APIKEY",api_key)
			dohttpreq(weather_req, function(raw_data)
				local weather_data = json.decode(raw_data or {})
--				self:log("Found weather data for city " .. tostring(city_id))
				self:SetWeather(weather_data)
			end)
		elseif lat and lon then
			local weather_req = "http://api.openweathermap.org/data/2.5/weather?lat=$LAT&lon=$LON&appid=$APIKEY"
			--local weather_req = "http://api.openweathermap.org/data/2.5/weather?id=$CITY&appid=$APIKEY"; local api_key = "e7862b311bbe9f1bee723872dd5d2e81"; return string.gsub(weather_req,"$APIKEY",api_key)
			weather_req = string.gsub(weather_req,"$LON",string.format("%.2f",lon))
			weather_req = string.gsub(weather_req,"$LAT",string.format("%.2f",lat))
			weather_req = string.gsub(weather_req,"$APIKEY",api_key)
			dohttpreq(weather_req, function(raw_data)
				local weather_data = json.decode(raw_data or {})
--				self:log("Did weathery query: " .. weather_req)
--				self:log("Found weather data by lat/lon " .. tostring(lat) .. ", " .. tostring(lon))
				self:SetWeather(weather_data)
			end)
		end
	else
--		self:log("No location data found!")
	end
end

function MHP:SetWeather(weather_data)
	self:SetStardewWeather(weather_data)
end

function MHP:SetStardewWeather(weather_data)

	local data = self._huds.stardew
	local weather_icon = data.get_weather_icon("sun")
	if weather_data then
	
		local weather_name
		if weather_data then 
			if type(weather_data.weather) == "table" then 
				for i,_weather in pairs(weather_data.weather) do 
					if _weather.main then 
						weather_name = _weather.main
						break
					end
				end
			end
		end
		weather_name = weather_name or "Clear"
		local weather_type = data.weather_ids[weather_name] or "sun"
	
		local season = "Spring"
		local month_num = tonumber(os.date("%m"))
		if month_num == 12 or month_num <= 2 then 
			season = "Winter"
		elseif month_num <= 5 then 
			season = "Spring"
		elseif month_num <= 8 then
			season = "Summer"
		elseif month_num <= 11 then
			season = "Fall"
		end
		
		if season == "Spring" or season == "Summer" then 
			if weather_type == "wind" then 
				weather_icon = data.get_weather_icon("wind_spring")
			end
		elseif season == "Winter" or season == "Fall" then
			if weather_type == "wind" then 
				weather_icon = data.get_weather_icon("wind_fall")
			end
		end
		weather_icon = weather_icon or data.get_weather_icon(weather_type)
	else
--		self:log("Location data not found!")
	end
	local stardew_box = data.panel:child("stardew_box")
	stardew_box:child("stardew_weather"):set_image(data.weather_atlas_name,unpack(weather_icon))
end

function MHP:SetStardewSeason()
	local data = self._huds.stardew
	local season_icon = data.get_season_icon("Spring")
	local season = "Spring"
	local month_num = tonumber(os.date("%m"))
	if month_num == 12 or month_num <= 2 then 
		season = "Winter"
	elseif month_num <= 5 then 
		season = "Spring"
	elseif month_num <= 8 then
		season = "Summer"
	elseif month_num <= 11 then
		season = "Fall"
	end
	local season_icon = data.get_season_icon(season)
	local stardew_box = data.panel:child("stardew_box")
	stardew_box:child("stardew_season"):set_image(data.seasons_atlas_name,unpack(season_icon))
end


-- DOOM (classic 1994)

function MHP:_create_hud_doom(hud)

	local doom = hud:panel({
		name = "doom",
		layer = 0
	})
	self._huds.doom.panel = doom
	local data = self._huds.doom
	
	local doom_hud = doom:bitmap({
		name = "doom_hud",
		texture = "textures/doom_hud",
		layer = -2
	})
	doom_hud:set_position((doom:w() - doom_hud:w())/2,doom:h() - (doom_hud:h() + data.ver_offset))
	
	local doomguy_portrait = doom:bitmap({
		name = "doomguy_portrait",
		texture = "textures/doom_portrait_atlas",
		texture_rect = data.get_rect("ST"),
		layer = 1,
		w = 128,
		h = 128
	})
	
	doomguy_portrait:set_position((doom:w() - doomguy_portrait:w()) / 2, doom_hud:y())
	
	
	local text_y = doom_hud:y() + data.font_y
	
	local ammo_label = doom:text({
		name = "ammo_label",
--		align = "right",
		layer = 2,
		text = "20%",
		x = 50,
		y = text_y,
		font = self._fonts.doom,
		font_size = data.font_size,
		color = self.color_data.doom_red,
		visible = true
	})
	local health_label = doom:text({
		name = "health_label",
--		align = "right",
		layer = 2,
		text = "30%",
		x = 270,
		y = text_y,
		font = self._fonts.doom,
		font_size = data.font_size,
		color = self.color_data.doom_red,
		visible = true
	})
	local armor_label = doom:text({
		name = "armor_label",
--		align = "right",
		layer = 2,
		text = "40%",
		x = 760,
		y = text_y,
		font = self._fonts.doom,
		font_size = data.font_size,
		color = self.color_data.doom_red,
		visible = true
	})
	
	
	
end

function MHP:SetDoomHealth(current,total)
	if total then
		if current == 0 then 
			self:SetDoomFace("DEAD")
		else
		
			local lost = (self.info.health_current - current) / total
			if math.abs(lost) > 0.2 then 
				self:SetDoomFace("OUCH",math.round((1 - (current/total)) * self._huds.doom.DAMAGE_TIERS ))
			end
			
		end
		local data = self._huds.doom
		local panel = data.panel
		local ratio = current / total
		panel:child("health_label"):set_text(string.format("%d",ratio * 100) .. "%")
	end
end

function MHP:SetDoomArmor(current,total)
	if total and total > 0 then
		local data = self._huds.doom
		local panel = data.panel
		local ratio = current / total
		panel:child("armor_label"):set_text(string.format("%d",ratio * 100) .. "%")
	end
end

function MHP:SetDoomAmmo(mag,reserve,max_mag)
	local data = self._huds.doom
	local panel = data.panel
	panel:child("ammo_label"):set_text(string.format("%d",mag))
end

function MHP:SetDoomFace(name,hurt_level,skip_interval)
	name = name or "ST"
	local data = self._huds.doom
	if not hurt_level then 
		hurt_level = math.round(1 - (self.info.health_current / self.info.health_total)) * self._huds.doom.DAMAGE_TIERS
	end
	data.panel:child("doomguy_portrait"):set_image(data.atlas_name,unpack(data.get_rect(name,hurt_level)))
	if not skip_interval then 
		self._update_intervals.doomface_t = Application:time() + 2
	end
end

-- Katamari Damacy (prince running + globe)

function MHP:_create_hud_katamari(hud)

	local katamari = hud:panel({
		name = "katamari",
		layer = -1
	})
	self._huds.katamari.panel = katamari
	local data = self._huds.katamari
	
	local earth_h = 128
	local earth_w = 256
	local katamari_earth = katamari:bitmap({
		name = "katamari_earth",
		texture = "textures/katamari_earth",
		x = katamari:w() - earth_w,
		y = katamari:h() - earth_h,
		w = earth_w,
		h = earth_h,
		layer = 4
	})
	
	local prince = katamari:bitmap({
		name = "katamari",
		texture = "textures/katamari_atlas",
		texture_rect = {
			0 * data.rect_w, 1 * data.rect_h, data.rect_w, data.rect_h
		},
		x = katamari_earth:x() + 75,
		y = katamari_earth:y() - 50,
		w = data.rect_w * data.prince_scale,
		h = data.rect_h * data.prince_scale,
		layer = 5
	})
	
end


-- The Binding of Isaac

function MHP:_create_hud_boi(hud)

	local boi = hud:panel({
		name = "boi",
		layer = -1
	})
	self._huds.boi.panel = boi
	local data = self._huds.boi
	
	local boi_scale = data.hud_scale
	
	local boi_hud = boi:bitmap({
		name = "boi_hud",
		texture = "textures/boi_hud"
	})
	boi_hud:set_size(boi_hud:w() * boi_scale,boi_hud:h() * boi_scale)
	boi_hud:set_position((boi:w() - boi_hud:w()) / 2,0)
	
	local y = 0
	for _i = 1,data.max_hearts do 
		local i = _i - 1
		local col_num = i % data.max_per_row
		local row_num = math.floor(i / data.max_per_row)
		boi:bitmap({
			name = "heart_" .. tostring(_i),
			texture = data.atlas_name,
			texture_rect = {0,0,data.heart_size,data.heart_size},
			w = data.heart_size * boi_scale,
			h = data.heart_size * boi_scale,
			x = boi_hud:x() + (data.hearts_x * boi_scale) + (boi_scale * col_num * data.heart_size),
			y = boi_hud:y() + (data.hearts_y * boi_scale) + (boi_scale * row_num * data.heart_size),
			layer = 1
		})
		
	end
	
	local coins_label = boi:text({
		name = "coins_label",
		layer = 2,
		text = "x00",
		x = boi_hud:x() + data.text_x,
		y = data.coins_y,
		font = self._fonts.doom,
		font_size = data.font_size,
		color = Color.white,
		visible = true
	})
	
	local bombs_label = boi:text({
		name = "bombs_label",
		layer = 2,
		text = "x03",
		x = boi_hud:x() + data.text_x,
		y = data.bombs_y,
		font = self._fonts.doom,
		font_size = data.font_size,
		color = Color.white,
		visible = true
	})
	
	local keys_label = boi:text({
		name = "keys_label",
		layer = 2,
		text = "x01",
		x = boi_hud:x() + data.text_x,
		y = data.keys_y,
		font = self._fonts.doom,
		font_size = data.font_size,
		color = Color.white,
		visible = true
	})
	
	
	
	
	
end

function MHP:SetBOIBombs(amount)
	self._huds.boi.panel:child("bombs_label"):set_text("x" .. string.format("%02d",math.clamp(amount,0,99)))
end

function MHP:SetBOIKeys(amount)
	self._huds.boi.panel:child("keys_label"):set_text("x" .. string.format("%02d",math.clamp(amount,0,99)))
end

function MHP:SetBOICoins(amount)
	self._huds.boi.panel:child("coins_label"):set_text("x" .. string.format("%02d",math.clamp(amount,0,99)))
end

function MHP:SetBOIHealth(current,total)
	local ratio = current
	if not current then 
		return
	elseif total then 
		ratio = (current / total)
	end
	ratio = 1 - ratio
	
	local data = self._huds.boi
	local panel = data.panel
	
	for i = 1,data.max_hearts do 
		local tick = panel:child("heart_" .. i)
		local r = 1 - ((i - 1) / data.max_hearts)
		if math.floor(r * 10) >= math.floor(ratio * 10) then
			if r * 10 < ratio * 10 then 
				tick:set_image(data.atlas_name,0,data.heart_size,data.heart_size,data.heart_size)
			else
				tick:set_image(data.atlas_name,0,0,data.heart_size,data.heart_size)
			end
		else
			tick:set_image(data.atlas_name,2 * data.heart_size,0,data.heart_size,data.heart_size,data.heart_size)
		end
	end
end


-- Destiny 2 Rank-Up screen animation

function MHP:_create_destiny_hud(hud)

	local destiny = hud:panel({
		name = "destiny",
		layer = -1
	})
	self._huds.destiny.panel = destiny
	local data = self._huds.destiny
	local blue = self.color_data.destiny_blue
	local orange = self.color_data.destiny_orange
	local stripe_angle = 90 + data.STRIPE_ANGLE
	local stripe_h = data.STRIPE_H
	
	
	
	local rankup_master = destiny:panel({
		name = "rankup_master",
		layer = 77
	})
	local center_x = rankup_master:w() / 2
	local center_y = rankup_master:h() / 2
	
	
	local bg_rotator_2 = rankup_master:bitmap({ --medium rotator
		name = "bg_rotator_2",
		layer = 6,
		texture = data.rotator_texture_2,
		w = data.ROTATOR_SIZE_2,
		h = data.ROTATOR_SIZE_2,
		alpha = 0, --data.ROTATOR_ALPHA_2,
		visible = true
	})
	bg_rotator_2:set_center(center_x,center_y)
	
	local bg_rotator_3 = rankup_master:bitmap({ --small rotator
		name = "bg_rotator_3",
		layer = 6,
		texture = data.rotator_texture_3,
		w = data.ROTATOR_SIZE_3,
		h = data.ROTATOR_SIZE_3,
		alpha = 0, --data.ROTATOR_ALPHA_1,
		visible = true
	})
	bg_rotator_3:set_center(center_x,center_y)
	
	local rank_frame_square = rankup_master:bitmap({ --small rotator
		name = "rank_frame_square",
		layer = 1,
		texture = data.frame_square_texture,
		w = data.FRAME_SQUARE_W,
		h = data.FRAME_SQUARE_H,
		alpha = 0, --data.FRAME_ALPHA,
		visible = true
	})
	local rank_frame_diamond = rankup_master:bitmap({ --small rotator
		name = "rank_frame_diamond",
		layer = 1,
		texture = data.frame_diamond_texture,
		w = data.FRAME_DIAMOND_W,
		h = data.FRAME_DIAMOND_H,
		alpha = 0, --data.FRAME_ALPHA,
		visible = true
	})
	rank_frame_square:set_center(center_x,center_y)
	rank_frame_diamond:set_center(center_x,center_y)
	
	local rankup_crucible_emblem = rankup_master:bitmap({
		name = "rankup_crucible_emblem",
		texture = data.crucible_texture,
		color = Color.white,
		layer = 8,
		w = data.EMBLEM_W,
		h = data.EMBLEM_H,
		x = center_x - (data.EMBLEM_W / 2),
		y = center_y - (data.EMBLEM_H / 2),
		alpha = 0
	})
	
	local rankup_bound = rankup_master:panel({ --box boundary (horizontal bar)
		name = "rankup_bound",
		h = data.RANKUP_HEIGHT,
		y = (rankup_master:h() - data.RANKUP_HEIGHT) / 2
	})
	local center_box_y = rankup_bound:h() / 2
	
	local bg_rotator_1 = rankup_bound:bitmap({ --big rotator
		name = "bg_rotator_1",
		layer = 6,
		texture = data.rotator_texture_1,
		w = data.ROTATOR_SIZE_1,
		h = data.ROTATOR_SIZE_1,
		alpha = 0, --data.ROTATOR_ALPHA_1,
		visible = true
	})
	bg_rotator_1:set_center(center_x,center_box_y)
	
	local orange_1 = rankup_bound:bitmap({ --left/top
		name = "orange_1",
		w = data.ORANGE_W,
		h = data.ORANGE_H,
		texture = data.orange_stripe_texture,
--		rotation = stripe_angle,
		color = orange,
		layer = 4,
		x = -data.ORANGE_W,
--		y = -stripe_h / 2,
		visible = true
	})
	local orange_2 = rankup_bound:bitmap({ --right/bottom
		name = "orange_2",
		w = -data.ORANGE_W,
		h = data.ORANGE_H,
		texture = data.orange_stripe_texture,
--		rotation = stripe_angle,
		color = orange,
		layer = 4,
		x = 2 * rankup_bound:w(),
--		y = -stripe_h / 2,
		visible = true
	})
	orange_2:set_y(orange_2:h())
	orange_2:set_h(-orange_2:h())
	
	local blue_stripe = rankup_bound:gradient({
		name = "blue_stripe",
--		valign = "scale",
--		orientation = "vertical",
--		halign = "scale",
		h = data.BLUE_STRIPE_H,
		layer = 7,
		y = (rankup_bound:h() - data.BLUE_STRIPE_H) / 2
	})
	blue_stripe:set_gradient_points({
		0,
		blue:with_alpha(0),
		0.5,
		blue:with_alpha(0),
		0.6,
		blue:with_alpha(0),
		1,
		blue:with_alpha(0)
	})
	
	local diag_stripe_1 = rankup_bound:bitmap({
		name = "diag_stripe_1",
--		rotation = stripe_angle,
--		h = stripe_h,
		color = Color.white,
		layer = 5,
		alpha = data.STRIPE_ALPHA,
		texture = data.stripe_texture,
		x = -1000,
--		y = -stripe_h / 2,
		visible = true
	})
	local diag_stripe_2 = rankup_bound:bitmap({
		name = "diag_stripe_2",
--		rotation = stripe_angle,
--		h = stripe_h,
		color = Color.white,
		layer = 5,
		alpha = data.STRIPE_ALPHA,
		texture = data.stripe_texture,
		x = -1000,
--		y = -stripe_h / 2,
		visible = true
	})
	local diag_stripe_3 = rankup_bound:bitmap({
		name = "diag_stripe_3",
--		rotation = stripe_angle,
--		h = stripe_h,
		layer = 5,
		color = Color.white,
		alpha = data.STRIPE_ALPHA,
		texture = data.stripe_texture,
		x = -1000,
--		y = -stripe_h / 2,
		visible = true
	})
	local diag_stripe_4 = rankup_bound:bitmap({
		name = "diag_stripe_4",
--		rotation = stripe_angle,
--		h = stripe_h,
		layer = 5,
		color = Color.white,
		alpha = data.STRIPE_ALPHA,
		texture = data.stripe_texture,
		x = -1000,
--		y = -stripe_h / 2,
		visible = true
	})
	local diag_stripe_5 = rankup_bound:bitmap({
		name = "diag_stripe_5",
--		rotation = stripe_angle,
--		h = stripe_h,
		layer = 5,
		color = Color.white,
		alpha = data.STRIPE_ALPHA,
		texture = data.stripe_texture,
		x = -1000,
--		y = -stripe_h / 2,
		visible = true
	})
	
	diag_stripe_1:set_size(diag_stripe_1:w() * data.STRIPE_S_SCALE,diag_stripe_1:h() * data.STRIPE_S_SCALE)
	diag_stripe_2:set_size(diag_stripe_2:w() * data.STRIPE_S_SCALE,diag_stripe_2:h() * data.STRIPE_S_SCALE)
	diag_stripe_3:set_size(diag_stripe_3:w() * data.STRIPE_M_SCALE,diag_stripe_3:h() * data.STRIPE_M_SCALE)
	diag_stripe_4:set_size(diag_stripe_4:w() * data.STRIPE_L_SCALE,diag_stripe_4:h() * data.STRIPE_L_SCALE)
	diag_stripe_5:set_size(diag_stripe_5:w() * data.STRIPE_XL_SCALE,diag_stripe_5:h() * data.STRIPE_XL_SCALE)

	local rank_title_box = rankup_bound:panel({
		name = "rank_title_box",
		w = data.RANKUP_TITLE_W,
		h = data.RANKUP_TITLE_H,
		x = center_x - (data.RANKUP_TITLE_W / 2),
		y = center_box_y - (data.RANKUP_TITLE_H / 2)
	})
	
	local rank_title_bg = rank_title_box:rect({
		name = "rank_title_bg",
		color = Color.black,
		layer = 9,
		w = 0,
		alpha = data.RANK_TITLE_BG_ALPHA,
	})
	
	local rank_title_bg_white = rank_title_box:rect({
		name = "rank_title_bg_white",
		color = Color.white,
		layer = 9,
		alpha = 0 --data.RANK_TITLE_BG_ALPHA,
	})
	
	local rankup_title = rank_title_box:text({
		name = "rankup_title",
		text = "VALOR SUB RANK UP!",
		font = self._fonts.destiny_bold,
		font_size = data.FONTSIZE_RANKUP_TITLE,
		layer = 10,
		alpha = 0,
		color = Color.white,
		vertical = "center",
		align = "center"
	})
	
	
	local rankup_infobox = rankup_bound:panel({
		name = "rankup_infobox",
		w = data.RANKUP_INFOBOX_W,
		x = data.RANKUP_INFOBOX_X + center_x + (data.RANKUP_INFOBOX_W / 2),
		alpha = data.RANKUP_INFOBOX_ALPHA,
		layer = 4 -- parented panel priority?
	})
	
	local season_title = rankup_infobox:text({
		name = "season_title",
		text = "SEASON 10",
		font = self._fonts.destiny_normal,
		font_size = data.FONTSIZE_SEASON_TITLE,
		layer = 3,
		alpha = 0, --1
		y = center_box_y + 8,
		color = Color.white,
		align = "center"
	})
	
	local info_div = rankup_infobox:rect({
		name = "info_div",
		w = data.RANKUP_INFOBOX_DIV_W,
		h = data.RANKUP_INFOBOX_DIV_H,
		alpha = 0, --data.RANKUP_INFOBOX_DIV_ALPHA,
		color = Color.white,
		x = (rankup_infobox:w() - data.RANKUP_INFOBOX_DIV_W) / 2,
		y = center_box_y - (data.RANKUP_INFOBOX_DIV_H / 2),
		layer = 3
	})
	
	local rank_title = rankup_infobox:text({
		name = "rank_title",
		text = "GUARDIAN III",
		font = self._fonts.destiny_serif,
		font_size = data.FONTSIZE_RANK_TITLE,
		layer = 3,
		alpha = 0,
		y = center_box_y - 22,
		color = Color.white,
		align = "center",
		kern = data.RANK_KERN
	})	
	
	local rank_icon = rankup_bound:bitmap({
		name = "rank_icon",
		texture = data.ranks_atlas,
		texture_rect = data.get_rect(1),
		alpha = 0, --1,
		w = data.RANK_ICON_W,
		h = data.RANK_ICON_H,
		x = (center_x - data.RANK_ICON_W) / 2,
		y = (center_box_y - data.RANK_ICON_H) / 2,
		layer = 13,
		visible = true
	})
	
	local debug_rankup_infobox = rankup_infobox:rect({
		name = "debug_rankup_infobox",
		color = Color.white,
		alpha = 0.1,
		visible = false
	})
	
	local bg_skybox = rankup_bound:bitmap({
		name = "bg_skybox",
		layer = -1,
		alpha = 0,
--		w = rankup_bound:w(),
--		h = data.RANKUP_HEIGHT,
		texture = data.skybox_texture
	})
	local bg_w,bg_h = bg_skybox:size()
	local bg_scale = bg_w / rankup_bound:w()
	bg_skybox:set_size(rankup_bound:w(),bg_h / bg_scale)
	--[[
	local bg_w,bg_h = bg_skybox:size()
	local bg_scale = bg_h / data.RANKUP_HEIGHT
	bg_skybox:set_size(bg_w / bg_scale,data.RANKUP_HEIGHT)
	--]]
	
end

function MHP:RecreateDestinyRankup()
	local panel = self._huds.destiny.panel
	local parent = panel:parent()
	parent:remove(panel)
	self._huds.destiny.panel = nil
	self:_create_destiny_hud(parent)
end

function MHP.animate_drift(o,t,dt,start_t,duration,start_x,to_x,a)
--you... shall drift.
	local ratio = (t - start_t) / duration	
	a = a or 10
	local f = (1 - (1/(a * ratio))) * ((a + 1)/a)
	o:set_x(start_x + ((to_x - start_x) * f))
--	o:set_alpha(math.clamp(ratio,0,1))
end

function MHP.animate_fade(o,t,dt,start_t,duration,start_alpha,end_alpha,start_x,end_x,start_y,end_y,power)
	duration = duration or 1
	start_alpha = start_alpha or 1
	end_alpha = end_alpha or start_alpha
	
	local ratio = math.pow((t - start_t) / duration,tonumber(power) or 2)
	
	if ratio >= 1 then 
		o:set_alpha(end_alpha)
		if end_x then 
			o:set_x(end_x)
		end 
		if end_y then 
			o:set_y(end_y)
		end
		return true
	end
	o:set_alpha(start_alpha + (ratio * (end_alpha - start_alpha)))
	if start_x and end_x then 
		o:set_x(start_x + ((end_x - start_x) * ratio))
	end
	if start_y and end_y then 
		o:set_y(start_y + ((end_y - start_y) * ratio))
	end
end

function MHP.animate_wait(o,t,dt,start_t,duration)
	if t >= start_t + duration then 
		return true
	end
end

function MHP.animate_fade_resize(o,t,dt,start_t,duration,start_w,to_w,start_h,to_h,start_alpha,to_alpha,center_x,center_y,power)
	local ratio = math.pow((t - start_t) / duration,tonumber(power) or 2)	
--	local ratio = math.min(math.pow((t - start_t) / duration,power or 2),1)
	if start_h and to_h then 
		o:set_h(start_h + ((to_h - start_h) * ratio))
	end
	if start_w and to_w then 
		o:set_w(start_w + ((to_w - start_w) * ratio))
	end
	if start_alpha and to_alpha then 
		o:set_alpha(start_alpha + ((to_alpha - start_alpha) * ratio))
	end
	if center_x and center_y then 
		o:set_center(center_x,center_y)
	end
	if t >= start_t + duration then 
		return true
	end
end

function MHP.animate_gradient_progress_simple(o,t,dt,start_t,duration,color,color_2,spacer)
	color = color or MHP.color_data.destiny_blue
	color_2 = color_2 or Color(0,0,0):with_alpha(0)
	if t >= start_t + duration then 
		o:set_gradient_points({
			0,
			color,
			1,
			color
		})
		return true
	else
		spacer = spacer or 0.01
		local ratio = math.pow((t - start_t) / duration,2)
		o:set_gradient_points({
			0,
			color,
			math.clamp(ratio,0,1),
			color,
			math.clamp(ratio + spacer,0,1),
			color_2:with_alpha(0),
			1,
			color_2:with_alpha(0)			
		})
	end
end

--here be dragons
function MHP:StartDestinyRankup(rank_data)
	if self.info.is_animating_d2 or not (rank_data and rank_data.icon and rank_data.name) then 
		return
	end
	self.info.is_animating_d2 = true --set animating flag
	self:RecreateDestinyRankup()
	local data = self._huds.destiny
	local rankup_master = data.panel:child("rankup_master")
	local rankup_bound = rankup_master:child("rankup_bound")
	
	local center_x = rankup_master:w() / 2
	local center_y = rankup_master:h() / 2
	local center_box_y = rankup_bound:h() / 2
	
	
	local rank_icon = rankup_bound:child("rank_icon")
	
	rank_icon:set_alpha(0)
	rank_icon:set_image(data.ranks_atlas,unpack(data.get_rect(rank_data.icon)))
	rank_icon:set_size(data.RANK_ICON_W,data.RANK_ICON_H)
	rank_icon:set_position(center_x - (rank_icon:w() / 2),center_box_y - ((rank_icon:h() / 2) + 16))
	
	local stripe_1 = rankup_bound:child("diag_stripe_1")
	local stripe_2 = rankup_bound:child("diag_stripe_2")
	local stripe_3 = rankup_bound:child("diag_stripe_3")
	local stripe_4 = rankup_bound:child("diag_stripe_4")
	local stripe_5 = rankup_bound:child("diag_stripe_5")
	
	local orange_1 = rankup_bound:child("orange_1")
	local orange_2 = rankup_bound:child("orange_2")
	
	local bg_rotator_1 = rankup_bound:child("bg_rotator_1")
	local bg_rotator_2 = rankup_master:child("bg_rotator_2")
	local bg_rotator_3 = rankup_master:child("bg_rotator_3")
	
	
	local frame_square = rankup_master:child("rank_frame_square")
	local frame_diamond = rankup_master:child("rank_frame_diamond")
	
	local crucible_icon = rankup_master:child("rankup_crucible_emblem")
	local blue_stripe = rankup_bound:child("blue_stripe")
	
	local rank_title_box = rankup_bound:child("rank_title_box")
	local rankup_title = rank_title_box:child("rankup_title")
	local rank_title_bg = rank_title_box:child("rank_title_bg")
	local rank_title_bg_white = rank_title_box:child("rank_title_bg_white")
	
	local rankup_infobox = rankup_bound:child("rankup_infobox")
	local season_title = rankup_infobox:child("season_title")
	season_title:set_text(string.gsub("SEASON $num","$num",string.format("%d",10 + math.max((24242 - (tonumber(os.date("%m")) + (12 * tonumber(os.date("%Y"))))) / 3,0))))
	--show approximate season based on time (new seasons come out roughly every three months)
	--i figure it won't matter anyway since i don't think anyone will unironically use this mod
	
	if rank_data.id == 17 then 
--		season_title:set_text("VALOR RESET AVAILABLE")
	end
	local info_div = rankup_infobox:child("info_div")
	local rank_title = rankup_infobox:child("rank_title")
	rank_title:set_text(utf8.to_upper(rank_data.name))
	
	local bg_skybox = rankup_bound:child("bg_skybox")
	
	local stripe_alpha = data.STRIPE_ALPHA
	
	local title_box_center_x = rank_title_box:w() / 2
	local title_box_center_y = rank_title_box:h() / 2
	
-- t 0:00
	self:animate(orange_1,"animate_fade",nil,0.5,1,1,-orange_1:w(),0,nil,nil)
	self:animate(orange_2,"animate_fade",nil,0.5,1,1,2 * rankup_bound:w(),rankup_bound:w(),nil,nil)

	self:animate(blue_stripe,"animate_gradient_progress_simple",nil,0.75,self.color_data.destiny_blue,nil,0.1)
	
	--0.75?
	self:animate(stripe_1,"animate_drift",nil,0.25,0,50,1.5)
	self:animate(stripe_2,"animate_drift",nil,0.25,0,200,1.5)
	self:animate(stripe_3,"animate_drift",nil,0.25,0,800,1.5)
	self:animate(stripe_4,"animate_drift",nil,0.25,0,500,1.5)
	self:animate(stripe_5,"animate_drift",nil,0.25,0,25,1.5)



	self:AnimateWait(2/3,function()
		self:animate(rankup_title,"animate_fade",nil,0.5,0,1) 
	end)
	self:AnimateWait(0.5,function()
		self:animate(crucible_icon,"animate_fade",nil,0.75,0,1)
	
		self:animate(rank_title_bg,"animate_fade_resize",nil,1/3,0,data.RANKUP_TITLE_W,nil,nil,data.RANK_TITLE_BG_ALPHA,data.RANK_TITLE_BG_ALPHA,title_box_center_x,title_box_center_y,3) --center_x,center_box_y)
		self:AnimateWait(0.2,function()
			self:animate(rank_title_bg_white,"animate_fade_resize",nil,0.8,0,data.RANKUP_TITLE_W,nil,nil,data.RANK_TITLE_BG_ALPHA,0,title_box_center_x,title_box_center_y,3)--center_x,center_box_y)
		end)
		self:animate(bg_rotator_1,"animate_fade",nil,0.5,0,data.ROTATOR_ALPHA_1)
		self:animate(bg_skybox,"animate_fade",nil,0.5,0,1)
	end)

	self:AnimateWait(2,function()
		self:animate(rank_title_bg_white,"animate_fade",function() --fadein quick
			self:animate(rank_title_bg_white,"animate_fade",nil,0.25,data.RANK_TITLE_BG_ALPHA,0) --fadeout quick
		end,0.0625,0,data.RANK_TITLE_BG_ALPHA)
		--0.25 instead of 0.0625?
	end)
	
	self:AnimateWait(2.25,function()
		self:animate(rank_title_box,"animate_fade_resize",function(o) o:hide() end,0.5,nil,nil,data.RANKUP_TITLE_H,0,nil,nil,center_x,center_box_y,3)
		self:animate(crucible_icon,"animate_fade",nil,0.5,1,0)
		
	end)
	
	self:AnimateWait(2.5,function()
		--todo cubic
		self:animate(stripe_1,"animate_fade",nil,0.5125,stripe_alpha,0,stripe_1:x(),rankup_bound:w()+10)
		self:animate(stripe_2,"animate_fade",nil,0.5125,stripe_alpha,0,stripe_2:x(),rankup_bound:w()+10)
		self:animate(stripe_3,"animate_fade",nil,0.5125,stripe_alpha,0,stripe_3:x(),rankup_bound:w()+10)
		self:animate(stripe_4,"animate_fade",nil,0.5125,stripe_alpha,0,stripe_4:x(),rankup_bound:w()+10)
		self:animate(stripe_5,"animate_fade",nil,0.5125,stripe_alpha,0,stripe_5:x(),rankup_bound:w()+10)
		
		self:animate(bg_rotator_2,"animate_fade_resize",nil,0.75,data.ROTATOR_SIZE_2 * data.ROTATOR_SIZE_MUL,data.ROTATOR_SIZE_2,data.ROTATOR_SIZE_2 * data.ROTATOR_SIZE_MUL,data.ROTATOR_SIZE_2,0,data.ROTATOR_ALPHA_2,center_x,center_y,0.25)
	end)
	
	self:AnimateWait(8/3,function()
			--split orange
			orange_1:set_size(rankup_bound:w() * 1.1,data.RANKUP_HEIGHT/2)
			orange_1:set_position(0,0)
			orange_2:set_size(rankup_bound:w() * 1.1,data.RANKUP_HEIGHT/2)
			orange_2:set_position(0,data.RANKUP_HEIGHT/2)
			orange_1:set_image(data.orange_stripe_texture,100,100,1,1)
			orange_2:set_image(data.orange_stripe_texture,100,100,1,1)
			self:animate(orange_1,"animate_fade",nil,2/3,nil,nil,nil,nil,orange_1:y(),-orange_1:h())
			self:animate(orange_2,"animate_fade",nil,2/3,nil,nil,nil,nil,orange_2:y(),data.RANKUP_HEIGHT)
	end)
	self:AnimateWait(2.75,function()
		self:animate(blue_stripe,"animate_fade",nil,0.25,blue_stripe:alpha(),0)
	end)
	
	self:AnimateWait(2.85,function()
		self:animate(bg_rotator_3,"animate_fade_resize",nil,2/3,data.ROTATOR_SIZE_3 * data.ROTATOR_SIZE_MUL,data.ROTATOR_SIZE_3,data.ROTATOR_SIZE_3 * data.ROTATOR_SIZE_MUL,data.ROTATOR_SIZE_3,0,data.ROTATOR_ALPHA_2,center_x,center_y,0.25)
		self:animate(frame_diamond,"animate_fade_resize",nil,0.5,data.FRAME_DIAMOND_W * data.ROTATOR_SIZE_MUL,data.FRAME_DIAMOND_W,data.FRAME_DIAMOND_H * data.ROTATOR_SIZE_MUL,data.FRAME_DIAMOND_H,0,data.FRAME_ALPHA,center_x,center_y,0.5)
		self:animate(rank_icon,"animate_fade",nil,2/3,0,1,nil,nil,rank_icon:y(),center_box_y - (rank_icon:h() / 2),0.5)
		
		self:animate(season_title,"animate_fade",nil,0.75,0,1,nil,nil,center_box_y - 2,center_box_y + 8)
		self:animate(info_div,"animate_fade",nil,0.75,0,1,nil,nil,center_box_y - ((data.RANKUP_INFOBOX_DIV_H / 2) + 10),center_box_y - (data.RANKUP_INFOBOX_DIV_H / 2))
		--season 10 + div drop fadein here (exp 0.5) (~0.66s)
	end)
	
	self:AnimateWait(3,function()
		self:animate(frame_square,"animate_fade_resize",nil,0.5,data.FRAME_SQUARE_W * data.ROTATOR_SIZE_MUL,data.FRAME_SQUARE_W,data.FRAME_SQUARE_H * data.ROTATOR_SIZE_MUL,data.FRAME_SQUARE_H,0,data.FRAME_ALPHA,center_x,center_y,0.5)
	end)
	
	self:AnimateWait(3.25,function()		
		self:animate(rank_title,"animate_fade",nil,0.75,0,1,nil,nil,center_box_y - 32,center_box_y - 22)
	end)

	self:AnimateWait(6.5,function()					
		self:animate(rank_icon,"animate_fade",nil,0.5,1,0,nil,nil,rank_icon:y(),rank_icon:y() + 32)
	end)
	
	self:AnimateWait(20/3,function()
		self:animate(frame_square,"animate_fade_resize",nil,1/3,frame_square:w(),frame_square:w() * data.ROTATOR_SIZE_MUL,data.FRAME_SQUARE_H,data.FRAME_SQUARE_H * data.ROTATOR_SIZE_MUL,frame_square:alpha(),0,center_x,center_y,2)
	end)
	
	self:AnimateWait(6.75,function()
		self:animate(bg_rotator_2,"animate_fade_resize",nil,0.5,data.ROTATOR_SIZE_2,data.ROTATOR_SIZE_2 * data.ROTATOR_SIZE_MUL,data.ROTATOR_SIZE_2,data.ROTATOR_SIZE_2 * data.ROTATOR_SIZE_MUL,data.FRAME_ALPHA,0,center_x,center_y,2)
		--season 10 + div drop fadeout here (0.75s)
		self:animate(season_title,"animate_fade",nil,0.75,1,0,nil,nil,season_title:y(),season_title:y() + 32)
		self:animate(info_div,"animate_fade",nil,0.75,1,0,nil,nil,info_div:y(),info_div:y() + 32)
	end)
	
	self:AnimateWait(6.85,function()
		self:animate(frame_diamond,"animate_fade_resize",nil,0.5,frame_diamond:w(),frame_diamond:w() * data.ROTATOR_SIZE_MUL,data.FRAME_DIAMOND_H,data.FRAME_DIAMOND_H * data.ROTATOR_SIZE_MUL,frame_diamond:alpha(),0,center_x,center_y,2)
	end)
	
	self:AnimateWait(7,function()
		self:animate(bg_rotator_3,"animate_fade_resize",nil,0.25,data.ROTATOR_SIZE_3,data.ROTATOR_SIZE_3 * data.ROTATOR_SIZE_MUL,data.ROTATOR_SIZE_3,data.ROTATOR_SIZE_3 * data.ROTATOR_SIZE_MUL,data.FRAME_ALPHA,0,center_x,center_y,2)				
		self:animate(rankup_master,"animate_fade",Panel.hide,0.5,rankup_master:alpha(),0)
	end)
	
	self:AnimateWait(7.1,function()
		self:animate(rank_title,"animate_fade",
			function ()
				self.info.is_animating_d2 = false --set flag
			end
		,0.75,1,0,nil,nil,rank_title:y(),rank_title:y() + 32)
	end)
end

function MHP:StartDestinyRankupOld(rank) --obsolete
	self:RecreateDestinyRankup()
	local data = self._huds.destiny
	local rankup_master = data.panel:child("rankup_master")
	local rankup_bound = rankup_master:child("rankup_bound")
	
	local center_x = rankup_master:w() / 2
	local center_y = rankup_master:h() / 2
	local center_box_y = rankup_bound:h() / 2
	
	
	local rank_icon = rankup_bound:child("rank_icon")
	
	rank_icon:set_alpha(0)
	rank_icon:set_image(data.ranks_atlas,unpack(data.get_rect(rank)))
	rank_icon:set_size(data.RANK_ICON_W,data.RANK_ICON_H)
	rank_icon:set_position(center_x - (rank_icon:w() / 2),center_box_y - ((rank_icon:h() / 2) + 16))
	
	local stripe_1 = rankup_bound:child("diag_stripe_1")
	local stripe_2 = rankup_bound:child("diag_stripe_2")
	local stripe_3 = rankup_bound:child("diag_stripe_3")
	local stripe_4 = rankup_bound:child("diag_stripe_4")
	local stripe_5 = rankup_bound:child("diag_stripe_5")
	
	local orange_1 = rankup_bound:child("orange_1")
	local orange_2 = rankup_bound:child("orange_2")
	
	local bg_rotator_1 = rankup_bound:child("bg_rotator_1")
	local bg_rotator_2 = rankup_master:child("bg_rotator_2")
	local bg_rotator_3 = rankup_master:child("bg_rotator_3")
	
	bg_rotator_2:set_alpha(0)
	bg_rotator_3:set_alpha(0)
	
	local frame_square = rankup_master:child("rank_frame_square")
	local frame_diamond = rankup_master:child("rank_frame_diamond")
	
	local crucible_icon = rankup_master:child("rankup_crucible_emblem")
	local blue_stripe = rankup_bound:child("blue_stripe")
	
	local rank_title_box = rankup_bound:child("rank_title_box")
	local rank_title_bg = rank_title_box:child("rank_title_bg")
	local rank_title_bg_white = rank_title_box:child("rank_title_bg_white")
	
	local rank_title = rank_title_box:child("rank_title")
	
	local rankup_infobox = rankup_bound:child("rankup_infobox")
	local season_title = rankup_infobox:child("season_title")
	local info_div = rankup_infobox:child("info_div")
	local rank_title = rankup_infobox:child("rank_title")
	
--	local rank_icon = rankup_bound:child("rankup_bound")
	
	local bg_skybox = rankup_bound:child("bg_skybox")
	
	local stripe_alpha = data.STRIPE_ALPHA
	
	local title_box_center_x = rank_title_box:w() / 2
	local title_box_center_y = rank_title_box:h() / 2
	
	
	--1
	self:animate(stripe_1,"animate_drift",nil,0.25,0,50,1.5)
	self:animate(stripe_2,"animate_drift",nil,0.25,0,200,1.5)
	self:animate(stripe_3,"animate_drift",nil,0.25,0,800,1.5)
	self:animate(stripe_4,"animate_drift",nil,0.25,0,500,1.5)
	self:animate(stripe_5,"animate_drift",nil,0.25,0,25,1.5)

	self:animate(orange_1,"animate_fade",nil,0.5,1,1,-orange_1:w(),0,nil,nil)
	self:animate(orange_2,"animate_fade",nil,0.5,1,1,2 * rankup_bound:w(),rankup_bound:w(),nil,nil)

	self:animate(crucible_icon,"animate_fade",nil,0.85,0,1)




	self:animate(blue_stripe,"animate_gradient_progress_simple",nil,0.5,self.color_data.destiny_blue,nil,0.1)
	
	self:animate(rank_title_bg,"animate_fade_resize",pulse_white,0.5,0,data.RANKUP_TITLE_W,nil,nil,data.RANK_TITLE_BG_ALPHA,data.RANK_TITLE_BG_ALPHA,title_box_center_x,title_box_center_y,3) --center_x,center_box_y)
	
	self:AnimateWait(0.4,function()
			--simple fadein "VALOR SUBRANK UP!"
		self:animate(rank_title,"animate_fade",nil,0.5,0,1) 
		
		--title bg fadein and grow
		self:AnimateWait(0.5,function()
			if alive(rank_title_bg_white) then 
				self:animate(rank_title_bg_white,"animate_fade_resize",nil,0.5,0,data.RANKUP_TITLE_W,nil,nil,data.RANK_TITLE_BG_ALPHA,0,title_box_center_x,title_box_center_y,3)--center_x,center_box_y)
			end	
		end)
		
		self:AnimateWait(2.75,function()
			if alive(rank_title_bg_white) then 
				self:animate(rank_title_bg_white,"animate_fade",function() --fadein quick
					self:animate(rank_title_bg_white,"animate_fade",nil,0.0625,data.RANK_TITLE_BG_ALPHA,0) --fadeout quick
				end,0.0625,0,data.RANK_TITLE_BG_ALPHA)
			end
		end)
		
	end)
	
	self:AnimateWait(1.66,function()
		self:animate(crucible_icon,"animate_fade",nil,0.75,1,0)
	end)
	
	self:AnimateWait(3,function()
		if alive(stripe_1) then 
		--todo cubic
			self:animate(stripe_1,"animate_fade",nil,0.5,stripe_alpha,0,stripe_1:x(),rankup_bound:w()+100)
			self:animate(stripe_2,"animate_fade",nil,0.5,stripe_alpha,0,stripe_2:x(),rankup_bound:w()+100)
			self:animate(stripe_3,"animate_fade",nil,0.5,stripe_alpha,0,stripe_3:x(),rankup_bound:w()+100)
			self:animate(stripe_4,"animate_fade",nil,0.5,stripe_alpha,0,stripe_4:x(),rankup_bound:w()+100)
			self:animate(stripe_5,"animate_fade",nil,0.5,stripe_alpha,0,stripe_5:x(),rankup_bound:w()+100)
		end
		
		--fadein rank icon from top
		self:AnimateWait(0.25,function()
			self:animate(rank_icon,"animate_fade",function() --fadein
				self:AnimateWait(3,function()
				
					--fadeout rank, frames, rotators
					--and then final panel
					self:animate(rank_icon,"animate_fade",nil,0.5,1,0,nil,nil,rank_icon:y(),rank_icon:y() + 32)
					
					self:AnimateWait(0.1,function()
						self:animate(frame_square,"animate_fade_resize",nil,0.5,frame_square:w(),frame_square:w() * data.ROTATOR_SIZE_MUL,data.FRAME_SQUARE_H,data.FRAME_SQUARE_H * data.ROTATOR_SIZE_MUL,frame_square:alpha(),0,center_x,center_y,2)
					end)
					self:AnimateWait(0.2,function()
						self:animate(bg_rotator_2,"animate_fade_resize",nil,1,data.ROTATOR_SIZE_2,data.ROTATOR_SIZE_2 * data.ROTATOR_SIZE_MUL,data.ROTATOR_SIZE_2,data.ROTATOR_SIZE_2 * data.ROTATOR_SIZE_MUL,data.FRAME_ALPHA,0,center_x,center_y,2)
					end)
					self:AnimateWait(0.33,function()
						self:animate(frame_diamond,"animate_fade_resize",nil,0.5,frame_diamond:w(),frame_diamond:w() * data.ROTATOR_SIZE_MUL,data.FRAME_DIAMOND_H,data.FRAME_DIAMOND_H * data.ROTATOR_SIZE_MUL,frame_diamond:alpha(),0,center_x,center_y,2)
					end)
					self:AnimateWait(0.5,function()
						self:animate(bg_rotator_3,"animate_fade_resize",nil,0.5,data.ROTATOR_SIZE_3,data.ROTATOR_SIZE_3 * data.ROTATOR_SIZE_MUL,data.ROTATOR_SIZE_3,data.ROTATOR_SIZE_3 * data.ROTATOR_SIZE_MUL,data.FRAME_ALPHA,0,center_x,center_y,2)				
						self:animate(rankup_master,"animate_fade",Panel.hide,0.66,rankup_master:alpha(),0)
					end)
				end)
			end
			,1,0,1,nil,nil,rank_icon:y(),center_box_y - (rank_icon:h() / 2),0.5)
		end)
		
		--fadein rotators and frames
		self:animate(bg_rotator_2,"animate_fade_resize",nil,1,data.ROTATOR_SIZE_2 * data.ROTATOR_SIZE_MUL,data.ROTATOR_SIZE_2,data.ROTATOR_SIZE_2 * data.ROTATOR_SIZE_MUL,data.ROTATOR_SIZE_2,0,data.ROTATOR_ALPHA_2,center_x,center_y,0.25)
		self:AnimateWait(0.5,function()
			self:animate(bg_rotator_3,"animate_fade_resize",nil,1,data.ROTATOR_SIZE_3 * data.ROTATOR_SIZE_MUL,data.ROTATOR_SIZE_3,data.ROTATOR_SIZE_3 * data.ROTATOR_SIZE_MUL,data.ROTATOR_SIZE_3,0,data.ROTATOR_ALPHA_2,center_x,center_y,0.25)
			self:animate(frame_diamond,"animate_fade_resize",nil,1,data.FRAME_DIAMOND_W * data.ROTATOR_SIZE_MUL,data.FRAME_DIAMOND_W,data.FRAME_DIAMOND_H * data.ROTATOR_SIZE_MUL,data.FRAME_DIAMOND_H,0,data.FRAME_ALPHA,center_x,center_y,0.5)
		end)
		self:AnimateWait(1,function()
			self:animate(frame_square,"animate_fade_resize",nil,0.5,data.FRAME_SQUARE_W * data.ROTATOR_SIZE_MUL,data.FRAME_SQUARE_W,data.FRAME_SQUARE_H * data.ROTATOR_SIZE_MUL,data.FRAME_SQUARE_H,0,data.FRAME_ALPHA,center_x,center_y,0.5)			
		end)
	end)
	
	self:AnimateWait(3,function()
		
		--title bg fade/shrink
		self:AnimateWait(0.1,function() 
			if alive(rank_title_box) then 
				self:animate(rank_title_box,"animate_fade_resize",function(o)
					o:hide()
				end
				,0.33,nil,nil,data.RANKUP_TITLE_H,0,nil,nil,center_x,center_box_y,3)
			end

			
			
			--split orange
			orange_1:set_image("",1,1,1,1)
			orange_1:set_size(rankup_bound:w(),data.RANKUP_HEIGHT/2)
			orange_1:set_position(0,0)
			orange_1:set_color(self.color_data.destiny_orange)
			
			orange_2:set_image("",1,1,1,1)
			orange_2:set_size(rankup_bound:w(),data.RANKUP_HEIGHT/2)
			orange_2:set_position(0,data.RANKUP_HEIGHT/2)
			orange_2:set_color(self.color_data.destiny_orange)
			
			self:animate(blue_stripe,"animate_fade",nil,0.5,blue_stripe:alpha(),0)
			self:animate(orange_1,"animate_fade",nil,0.5,nil,nil,nil,nil,orange_1:y(),-orange_1:h())
			self:animate(orange_2,"animate_fade",nil,0.5,nil,nil,nil,nil,orange_2:y(),data.RANKUP_HEIGHT)

		end)
	end)
	
	--2

	
	--[[
--duration,start_w,to_w,start_h,to_h,start_alpha,to_alpha,center_x,center_y,power)
	
		phase 1:
			-white stripes move from left (quadratic movement, variable speed)
			-blue stripe gradient progress left to right (quadratic movement)
			*orange bars from left/right (cubic movement)
		phase 2:
			"subrank" bg rect grows horizontally from center
			crucible icon fades in 
				white "pulse" rect fades out & grows horizontally from center
				"subrank" title fades in
			(hold for ~2s)
		phase 3:
			white "pulse" fades in and back out immediately
				"subrank" bg shrinks vertically from center
				"subrank" title fades out
				crucible icon fades out
				blue stripe fades out
				orange stripes separate vertically (exit up/down)
				white stripes exit right (quadratic movement, variable speed)
		phase 4: 
			rotator 2 fades in and shrinks from 110% to 100% size
				rotator 3 fades in from 110% to 100% size
					rotators 2 and 3 begin rotating
				diamond and square frames fade in from 110% to 100% size
				season title, rank title, and info div fade in and drop
				rank icon fades in and drops 
			(hold for ~3s)
		phase 5
			rank icon fades out and drops
			square frame grows and fades out
				rotator 2 grows and fades out
				diamond frame grows and fades out
					rotator 3 grows and fades out
						
						season title fades out + drops
						info div fades out + drops
						rank title fades out + drops
						bg fades out (and rotator 1)
						
	
	rankup_panel:child("")
	--]]
	
	
	
end


-- Rocket League boost meter

function MHP:_create_hud_rocketleague(hud)
	local data = self._huds.rocketleague
	local SCALE = data.SCALE
	local w = data.PANEL_W * SCALE
	local h = data.PANEL_H * SCALE
	local BOOST_X = data.BOOST_X * SCALE
	local BOOST_Y = data.BOOST_Y * SCALE
	local rocketleague = hud:panel({
		name = "misc",
		layer = 2,
		w = w,
		h = h,
		x = BOOST_X + hud:w() - w,
		y = BOOST_Y + hud:h() - h
	})
	self._huds.rocketleague.panel = rocketleague
	
	local BOOST_LABEL_SHADOW_OFFSET = data.BOOST_LABEL_SHADOW_OFFSET * SCALE
	
	local BOOST_1_X = data.BOOST_1_X * SCALE
	local BOOST_1_Y = data.BOOST_1_Y * SCALE
	
	local BOOST_FONT_SIZE = data.BOOST_FONT_SIZE * SCALE
	local BOOST_LABEL_X = data.BOOST_LABEL_X * SCALE
	local BOOST_LABEL_Y = data.BOOST_LABEL_Y * SCALE
	
	local boost_radial = rocketleague:bitmap({
		name = "boost_radial",
		layer = 2,
		texture = data.boost_2_texture,
		rotation = data.BOOST_ANGLE,
		w = w,
		h = h,
		x = BOOST_1_X,
		y = BOOST_1_Y,
		render_template = "VertexColorTexturedRadial"
	})
--	boost_radial:set_center(rocketleague:w() / 2,rocketleague:h()/2)
	
	local boost_bg = rocketleague:bitmap({
		name = "boost_bg",
		layer = 1,
		texture = data.boost_1_texture,
--		rotation = data.BOOST_ANGLE,
		w = w,
		h = h
	})
	
	local boost_label = rocketleague:text({
		name = "boost_label",
		layer = 4,
		text = "100",
		align = "center",
		vertical = "center",
		x = BOOST_LABEL_X,
		y = BOOST_LABEL_Y,
		rotation = data.BOOST_LABEL_ANGLE,
		font = self._fonts.eurostile_ext,
		font_size = BOOST_FONT_SIZE,
		color = Color.white,
		visible = true
	})
	local boost_label_shadow = rocketleague:text({
		name = "boost_label_shadow",
		layer = 3,
		text = "100",
		align = "center",
		vertical = "center",
		blend_mode = "add",
		x = BOOST_LABEL_X + BOOST_LABEL_SHADOW_OFFSET,
		y = BOOST_LABEL_Y - BOOST_LABEL_SHADOW_OFFSET,
		rotation = data.BOOST_LABEL_ANGLE,
		font = self._fonts.eurostile_ext,
		font_size = BOOST_FONT_SIZE,
		color = self.color_data.rocketleague_orange,
		visible = true
	})
	
end

function MHP:SetRocketLeagueBoost(current,total)

	if total then 
		local ratio = current/total
		
		local data = self._huds.rocketleague
		local panel = data.panel
		local text = string.format("%d",ratio * 100)
		panel:child("boost_label"):set_text(text)
		panel:child("boost_label_shadow"):set_text(text)
		
		panel:child("boost_radial"):set_color(Color((3/8) + (ratio * 5/8),0,0))
	end
	
end



-- Misc cosmetic hud elements

function MHP:_create_misc(hud)

	local misc = hud:panel({
		name = "misc",
		layer = -1
	})
	self._huds.misc.panel = misc
	local data = self._huds.misc
	
	local eurotruck_scale = 0.5
	local eurotruck = misc:bitmap({
		name = "eurotruck",
		texture = "textures/misc_eurotruck",
		x = 0,
		y = 300,
		layer = -1
	})
	eurotruck:set_size(-eurotruck:w() * eurotruck_scale,eurotruck:h() * eurotruck_scale)	
	eurotruck:set_x(math.abs(eurotruck:w()))
--accidentally flipped the texture horizontally so the mirror is facing the wrong way, too lazy to re-export it	
--i'll just flip the width
	
	misc:bitmap({
		name = "civ_left",
		texture = "textures/misc_civ_left",
		x = 0,
		y = 0,
		layer = -1
	})

	local civ_right = misc:bitmap({
		name = "civ_right",
		texture = "textures/misc_civ_right",
		x = 0,
		y = 0,
		layer = -1
	})
	civ_right:set_x(misc:w() - civ_right:w())

	local bloons_scale = 0.5
	local bloons = misc:bitmap({
		name = "bloons",
		texture = "textures/misc_bloons",
		layer = 0
	})
	bloons:set_size(bloons:w() * bloons_scale,bloons:h() * bloons_scale)
	bloons:set_y(misc:h() - (bloons:h() + 150))
	bloons:set_x(misc:w() - (bloons:w() + 100))
	
	local terraria_hotbar = misc:bitmap({
		name = "terraria_hotbar",
		texture = "textures/terraria_hotbar",
		x = 210,
		y = 50,
		layer = 0
	})
	terraria_hotbar:set_size(terraria_hotbar:w() * 0.5,terraria_hotbar:h() * 0.5)
	
end


-- FTL: Faster Than Light crew info (just name + hp and a random FTL race icon)

function MHP:_create_ftl(hud)
	local data = self._huds.ftl
	local ftl = hud:panel({
		name = "ftl",
		layer = 3,
		x = data.hud_x,
		y = data.hud_y
	})
	self._huds.ftl.panel = ftl
--[[
	for i=1,4 do 
		local teammate = self:AddFTLTeammate(i)
		teammate:hide()
	end
--]]	
end

function MHP:AddFTLTeammate(i)
	local data = self._huds.ftl
	local ftl = data.panel
	
	if i and ftl and alive(ftl) then 
		local result = ftl:child("teammate_" .. tostring(i))
		if result and alive(result) then 
			result:show()
			return result
		end
	else
		return
	end
	
	local scale = data.scale
	local health_w = data.health_w * scale
	local health_h = data.health_h * scale
	local health_x = data.health_x * scale
	local health_y = data.health_y * scale
	
	local icon_size = data.icon_size * scale
	local icon_x = data.icon_x * scale
	local icon_y = data.icon_y * scale
	
	local teammate_w = data.teammate_w * scale
	local teammate_h = data.teammate_h * scale
	
	local teammate_margin_v = data.teammate_margin_v * scale
	
	local name_x = data.name_x * scale
	local name_y = data.name_y * scale
	local font_size = data.font_size * scale
	
	local teammate_panel = ftl:panel({
		name = "teammate_" .. tostring(i),
		layer = 3,
		w = teammate_w,
		h = teammate_h,
		y = (i - 1) * (teammate_h + teammate_margin_v)
	})
	local nameplate = teammate_panel:bitmap({
		name = "nameplate",
		layer = 1,
		texture = "textures/ftl_crew_plate",
		w = teammate_w,
		h = teammate_h
	})
	
	--ftl race icon;
--races are selected randomly from variants but distributed evenly among races
--the chance of getting a human is the same as getting an engi,
--even though there are 6 human variants and 1 engi variant
	local icon = teammate_panel:bitmap({
		name = "icon",
		layer = 2,
		texture = data.atlas_name,
		texture_rect = data.get_rect(),
		w = icon_size,
		h = icon_size,
		x = icon_x,
		y = icon_y
	})
	
	local name = teammate_panel:text({
		name = "name",
		layer = 4,
		text = "Bomfy M.",
		x = name_x,
		y = name_y,
		font = self._fonts.ftl,
		font_size = font_size,
		color = Color.white,
		visible = true
	})
	
	local health_bar = teammate_panel:rect({
		name = "health_bar",
		layer = 3,
		w = health_w,
		h = health_h,
		x = health_x + (teammate_panel:w() - health_w),
		y = health_y + (teammate_panel:h() - health_h),
		color = Color.green
	})
	
	local debug_ = teammate_panel:rect({
		name = "debug",
		color = Color(i/4,4/i,(i-4)/4),
		alpha = 0.5,
		visible = false
	})
	return teammate_panel
end

function MHP:RemoveFTLTeammate(i)
	local data = self._huds.ftl
	local ftl = data.panel
	if i and ftl and alive(ftl) then 
		local panel = ftl:child("teammate_" .. tostring(i))
		if panel and alive(panel) then 
			ftl:remove(panel)
			return true
		end
	end
	return false
end

function MHP:SetFTLHealth(i,current,total)
	local data = self._huds.ftl
	local ftl = data.panel
	if i and current and total and ftl and alive(ftl) then 
		local teammate = ftl:child("teammate_" .. tostring(i))
		if teammate and alive(teammate) then 
--			teammate:show()
			local ratio = current/total
			local hp_bar = teammate:child("health_bar")
			hp_bar:set_w(data.health_w * data.scale * ratio)
			if ratio <= data.health_threshold_empty then 
				hp_bar:set_color(self.color_data.ftl_bar_empty)
			elseif ratio <= data.health_threshold_low then 
				hp_bar:set_color(self.color_data.ftl_bar_low)
			else
				hp_bar:set_color(self.color_data.ftl_bar_full)
			end
		end
	end
end

function MHP:SetFTLTeammateName(i,raw_name)
	local data = self._huds.ftl
	local ftl = data.panel
	if i and raw_name and ftl and alive(ftl) then 
		local teammate = ftl:child("teammate_" .. tostring(i))
		if teammate and alive(teammate) then 
			local name = raw_name
			if string.len(raw_name) > data.name_max_len then
				name = string.sub(raw_name,1,data.name_max_len) .. "."
			end
			teammate:child("name"):set_text(name)
		end
	end
end


Hooks:Add("BaseNetworkSessionOnLoadComplete","MHP_OnLoadComplete",callback(MHP,MHP,"Init"))
Hooks:Add("JoyScoreCounter_SetScore","MHP_SetScore_JoyScore",function(...)
	Hooks:Remove("MHP_SetScore_NobleHUD")
	Hooks:Remove("MHP_SetScore_Builtin")
	MHP:SetScore(...)
end)
Hooks:Add("NobleHUD_OnAddScore","MHP_SetScore_NobleHUD",function(...)
	Hooks:Remove("MHP_SetScore_Builtin")
	MHP:SetScore(...)
end)